from img_holder import img_holder
from snd_holder import snd_holder
import constants as c_
from common_ import print_
from ball import ball

class char_body:
    _SH_DAMAGED = snd_holder(c_._SG_HITS, 0)
    _SH_ATTACHED = snd_holder(c_._SG_BODY, 0)
    _SH_UNCURSE = snd_holder(c_._SG_BOUNTY, 6)
    def __init__(self, char, attached_friction, detached_friction, solidity):
        self.char = char
        self.player = char.player
        self.attached = True

        self.init_solidity = solidity
        self.cursed = False # is now affected by bad bounty

        self.attached_friction = attached_friction 
        self.detached_friction = detached_friction

        #sounds
        self.sh_damaged = self._SH_DAMAGED
        self.sh_attached = self._SH_ATTACHED
        self.sh_uncurse = self._SH_UNCURSE
        self.now_sound = None
        
    def render(self, stor, visible, datafunc = None):
        ball.render(self, stor, visible, datafunc)
        if self.cursed:
            ball.render(self, stor, visible, self.get_nail_pic)
            

    def make_attached(self):
        self.attached = True
        self.friction = self.attached_friction
        self.char.total_attached += 1

    def make_detached(self):
        self.attached = False
        self.friction = self.detached_friction
        self.char.total_attached -= 1
        
    def uncurse(self):
        self.cursed = False 
        self.solidity = self.init_solidity
        if self.attached:
            self.friction = self.attached_friction
        else:
            self.friction = self.detached_friction

        self.now_sound = self.stor.sndf.get_sound(self.sh_uncurse)

    def curse(self):
        self.cursed = True
        self.solidity = 100000000
        self.friction = 0.97
        
    def damagable(self):
        return self.char.is_damagable

    def damages_b(self, b):
##        if b.__class__.__name__ == "spider_head":
##            if ((b.obj_gr != self.obj_gr) and
##                (b.obj_gr in c_._OGs_PLAYERS)):
##                print "\nchecking damages"
##                print b.damagable()
##                print b.attached
##                print not self.attached
        return (   (b.obj_gr in c_._OGs_PLAYERS) and
                   (b.obj_gr != self.obj_gr) and
                   (b.damagable()) and
                   (b.attached) and
                   (not self.attached)
               )

    def damage_b(self, b, imp_b):
##        if b.__class__.__name__ == "spider_head":
##            if ((b.obj_gr != self.obj_gr) and
##                (b.obj_gr in c_._OGs_PLAYERS)):
##                print "damaging", b.string
        dmg = int(self.player.info.strength * imp_b * 35.0 * b.vulnerability)
        if dmg:
            vl = dmg / 20.0 * 0.7
            if vl > 0.7: vl = 0.7
            b.now_sound = self.stor.sndf.get_sound(b.sh_damaged, volume = vl)

            
            b.player.info.incr_health(-dmg)

            print_( "damage to %s" % b.string )
            print_( b.player.info.health )
        
        

    def get_nail_pic(self):
        ih = img_holder(c_._IG_NAIL, 0)
        return self.stor.imgf.get_image(ih)

    def glue_b(self, b):
        self.now_sound = self.stor.sndf.get_sound(self.sh_attached, stop_all = False)

    def need_sound_when_hit_b(self, b):
        return False

        


    
