import os, sys
def prepare_for_importing():
    """function to prepare all folders for importing

        runs through subfolders of current_folder/include and adds
        everything  recursively"""
    def add_dir(dir):
        sys.path.append(dir)
        for sub in [os.path.join(dir, sub) for sub in os.listdir(dir)]:
            if os.path.isdir(sub):
                print sub
                add_dir(sub)
                
    dir = os.path.join(os.getcwd(), "include")
    if os.path.exists(dir): add_dir(dir)


import os
import pygame
from pygame.locals import *
from pygame import Rect

#functions to create our resources
def load_image(name, colorkey=None):
    ext = name.split(".")[-1]
    fullname = os.path.join('images', os.path.join(ext, name))
    try:
        image = pygame.image.load(fullname)
    except:
        print "    Couldn't load image:", fullname

        fullname = os.path.join('images', 'png', 'not_found.png')
        if os.path.exists(fullname):
            image = pygame.image.load(fullname)
        else:
            image = pygame.Surface((1, 1))
            
    image = image.convert()
    if colorkey is not None:
        if colorkey is -1:
            colorkey = image.get_at((0,0))
        image.set_colorkey(colorkey, RLEACCEL)
    return image, image.get_rect()

def copy_image(img):
    ck = img.get_colorkey()
    img.set_colorkey(None)
    al = img.get_alpha()
    img.set_alpha(None)
    img2 = pygame.Surface(img.get_rect().size)
    img2.blit(img, (0, 0))
    img2.set_colorkey(ck, RLEACCEL)
    img2.set_alpha(al, RLEACCEL)
    img.set_colorkey(ck, RLEACCEL)
    img.set_alpha(al, RLEACCEL)
    return img2
    

def blit_(stor, img, img_r, visible = True):
    if visible:
        stor.screen.blit(img, img_r)
    else:
        stor.screen.blit(stor.background, img_r, img_r)
    stor.dirty.new_rect(img_r)  

def blit_unerase(stor, img, img_r, visible = True):
    if visible:
        stor.screen.blit(img, img_r)
    else:
        stor.screen.blit(stor.background, img_r, img_r)
    stor.dirty.new_unerase_rect(img_r)  

def blit_part_(stor, img, img_r, img_r_source, visible = True):
    if visible:
        stor.screen.blit(img, img_r, img_r_source)
    else:
        stor.screen.blit(stor.background, img_r, img_r)
    stor.dirty.new_rect(img_r)  

def rend_text(text, color, size):
    image = pygame.font.Font(None, size).render(text, 1, color);
    #copy this image to a clear one so Alpha works when needed
    image2 = pygame.Surface(image.get_rect().size)
    image2.blit(image, (0, 0))
    colorkey = image2.get_at((0,0))
    image2.set_colorkey(colorkey, RLEACCEL)
    return image2, image2.get_rect()

def my_rotate(img, angle):
    "somehow pygame.transform.rotate doesn't preserve alpha value"
    newimg = pygame.transform.rotate(img, angle)
    newimg.set_alpha(img.get_alpha(), RLEACCEL)
    return newimg
def my_flip(img, x_axis, y_axis):
    newimg = pygame.transform.flip(img, x_axis, y_axis)
    newimg.set_alpha(img.get_alpha(), RLEACCEL)
    return newimg

def flip_blue_green(img):
    "original image shouldn't contain purple!!"
    w, h = img.get_rect().size
    for x in range(w):
        for y in range(h):
            c = list(img.get_at((x, y)))
            if ((c[0] < 40) or (c[2] > 20)):
                t = c[1]
                c[1] = c[2]
                c[2] = t
            img.set_at((x, y), tuple(c))
    return img

stor = None
def set_storage(i_stor):
    global stor
    stor = i_stor
    
def print_(s):
    stor.print_lock.acquire()
    print s
    stor.print_lock.release()

def get_timescale():
    return stor.settings.timescale


def set_my_icon(disp):
    s, sr = load_image("icon.png", None)
    disp.set_icon(s)
    
def RaiseNotImplementedError():
    raise NotImplementedError

if __name__ == "__main__":
    
    import os
    import sys
    print sys.path
    prepare_for_importing()
    print sys.path


