class holders_list(list):
    def __init__(self, holder_class, factory, autoload = None,
                 init_id = 0):
        """__init__(self, factory, autoload = None)

        autoload is a triple (_gr, start, size);
        if present, passed to self.load_group() immediately"""
        
        list.__init__(self)
        self.factory = factory
        self.holder_class = holder_class
        self.init_id = init_id

        if autoload:
            _gr, start, size = autoload
            self.load_group(_gr, start, size)

        self.new_session()


    def load_group(self, _gr, start = 0, size = None):
        del self[:]
        self.append_group(_gr, start, size)
        

    def append_group(self, _gr, start = 0, size = None):
        if size is None:
            size = len(factory.groups[_gr])
        for i in range(start, start + size):
            self.append(self.holder_class(_gr, i))

            
    def set_active(self, id):
        prev = self.active_id
        self.active_id = id
        self.active_changed = prev != id

        self.prev_active_id = prev

    def new_session(self):
        self.active_id = None
        self.active_changed = True
        self.prev_active_id = None
        self.set_active(self.init_id)
