from snake import snake
from spider import spider
from ball import ball
import constants as c_
import common_
from img_holder import img_holder
import pygame
from cloud import cloud
import __builtin__ #for "map" method which is overridden by the map class :)

_BRD = 0.05 #border (in 2.0x2.0 field)
_SNK = 0.5
_SPDR = 0.2
charclass = (snake, spider)


class map:
    def __init__(self):
        self.stor = None

        self.data = {
                    "background_id" : 4,
                    "toolbar_id" : 4,
                    "wall_id" : 1,
                    "bounty_type0" : 0,
                    "bounty_type1" : 0,
                    "bounty_type2" : 0,
                    "clouds_n" : 2,
                    "chardata": ( (#player1:
                                        (#if is snake:
                                            ((-1 + _BRD, -1 + _BRD, _SNK, 0),
                                             (12, 0, 5))), #(total, detached, min_body_len)
                                        (#if spider:
                                            ((-1 + _BRD + _SPDR,
                                              -1 + _BRD + _SPDR, -1, 0),
                                             None))),
                                  (#player2: empty means symmetric
                                  )
                                )
                    
                                             
                                    
                                                        
                    }

    def cwall(self, x, y):
        return ball(c_._OG_WALLS, self.stor, x, y, 
                    c_._IG_WALL, self.data["wall_id"],
                    friction = 1, solidity = 100000000, string = "WALL",
                    def_size = c_._WH_WALL,
                    visible = False
                    ),

    def ccloud(self, x, y, i_id):
        return cloud(c_._OG_CLOUDS, self.stor, x, y,
                     c_._IG_CLOUD, 0,
                     gm = self.gm,
                     id = i_id)
                     

    def apply(self, gm, stor, p1 = True, p2 = True):
        print "Applying map"
        self.stor = stor
        self.gm = gm

        #snakes
        ph = stor.physics
        rx, ry = ph.rx * 0.9, ph.ry * 0.9 #not to get out of field
        chars = stor.settings.get_characters(gm)
        chardata = self.data["chardata"]

        if p1:
            ch_class = charclass[chars[0]]
            p1_spawn_vect, p1_spawn_data = chardata[0][chars[0]]
            stor.p1.char = ch_class(stor, stor.p1, p1_spawn_vect, p1_spawn_data)

        if p2:
            ch_class = charclass[chars[1]]
            if chardata[1] == (): #symmetric
                p2_spawn_vect = __builtin__.map(lambda xy: -xy, chardata[0][chars[1]][0])
                p2_spawn_data = chardata[0][chars[1]][1]
            else:
                p2_spawn_vect, p2_spawn_data = chardata[1][chars[1]]
                
                
            stor.p2.char = ch_class(stor, stor.p2, p2_spawn_vect, p2_spawn_data)

        #walls
        stor.walls = [
                      self.cwall(0, 0)[0],
                      self.cwall(rx / 2.0, ry / 2.0)[0],
                      self.cwall(rx / 4.0, ry / 4.0)[0],
                      self.cwall(-rx / 2.0, -ry / 2.0)[0],
                      self.cwall(-rx / 4.0, -ry / 4.0)[0],

                      self.cwall(-rx *0.93, ry * 0.96)[0],
                      self.cwall(-rx *0.97, ry * 0.75)[0],
                      self.cwall(rx *0.93, -ry * 0.96)[0],
                      self.cwall(rx *0.97, -ry * 0.75)[0],
                      ]

#        print stor.walls
        for it in stor.walls:
            it.friction *= 0.5

        #clouds
        stor.clouds = [
                       self.ccloud(-rx/2, ry/2, 0),
                       self.ccloud(rx/2, -ry/2, 1)
                       ]
        assert(len(stor.clouds) == self.data["clouds_n"])
        stor.bounties = []
        
        #background
        self.build_background(stor, self.data["background_id"],
                              self.data["toolbar_id"])


        self.stor = None


    def build_background(self, stor, background_id = 0, toolbar_id = 0):
        ih_b = img_holder(c_._IG_BACKGROUNDS, background_id)
        ih_t = img_holder(c_._IG_TOOLBARS, toolbar_id)
        
        b = pygame.Surface(stor.screen.get_rect().size)
        
        toolb = stor.imgf.get_image(ih_t)
        back = stor.imgf.get_image(ih_b)
        
        b.blit(toolb.img[0], (0, 0))
        b.blit(back.img[0], (0, toolb.img[0].get_rect().height))

        #blit walls on background
        sav_screen = stor.screen
        stor.screen = b
        for it in stor.walls:
            it.render(stor, True, drawing_invisible = True)
        stor.screen = sav_screen
        
        stor.background = b



if __name__ == "__main__":

    step = 0.1
    crd = [-1 + a * step for a in range(10)]
    print crd
        
        
