from icon_group import icon_group
from icon_fps_val import icon_fps_val
from icon_text import icon_text
from icon import icon
import toolbar
import constants as c_
import pygame

class debug_info:
    def __init__(self, stor, gm):
        self.stor = stor
        self.gm = gm
        self.frames = None
        self.init_time = None
        self.time = None
        self.fps = None

        xy = stor.screen.get_rect().bottomleft
        w = toolbar.get_height(self.stor.imgf.scale)
        self.icon_gr = icon_group(self.stor,
                                  xy[0], xy[1] - w,
                                  w / 2, w / 2,
                                  left_to_right = 1)
        add = self.icon_gr.add_icon
        self.fps_value = add(icon_fps_val(self.stor, self), shift = (0.5, 0))
        add(icon_text(self.stor, c_._IG_STRINGS, c_._IG_S_FPS), shift = (1.4, 0))

    def new_session(self):
        self.frames = 0
        self.init_time = pygame.time.get_ticks()
        self.time = 1
        self.fps = 0
        self.stor.toolbar.debug_icon_gr = self.icon_gr
        
    def render(self, visible):
        self.icon_gr.render(visible)

    def inc_frames(self):
        self.frames += 1

    def maybe_reset(self):
        self.time = (pygame.time.get_ticks() - self.init_time) / 1000.0

        if self.time > 0.2:
            self.fps = float(self.frames) / self.time 
            self.frames = 0
            self.init_time = pygame.time.get_ticks()

##            self.fps = self.gm.clock.get_fps()
