import pygame

from constants import _GM
from debug_info import debug_info
from toolbar import toolbar
import constants as c_
from img_holder import img_holder
import threading
import time
from common_ import blit_, blit_unerase

class game_mode:

    def __init__(self, i_storage):
        self.stor = i_storage
        self.mode_next_id = None

        self.mouse_vis = True
        self.mouse_grab = 0

        self.chat = None
        self.debug_info = debug_info(self.stor, self)

        
    def session(self, chatboard = None):
#        print self.stor.p1.ball.crd

        self.chat = chatboard
        
        self.mode_next_id = _GM["DO_NOT_CHANGE"]
        self.n_threads = 0
        self.threads_must_stop = False
        self.clock = pygame.time.Clock()
        self.debug_info.new_session()
        self.frame_id = 0
        self.stor.dirty.new_session()

        self.pre_session()

        if (self.mode_next_id == _GM["DO_NOT_CHANGE"]):

            #if pre_session allows to stay, continue:
            pygame.mouse.set_visible(self.mouse_vis)
            pygame.event.set_grab(self.mouse_grab)
            self.init_place_mouse()

            #pre_session should set background:
            blit_unerase(self.stor, self.stor.background, self.stor.screen.get_rect())


            min_time_per_frame = int(1000.0 / c_._MAX_FPS)

        while True:
            if (self.mode_next_id != _GM["DO_NOT_CHANGE"]):
                break

            curtime = pygame.time.get_ticks()
            self.debug_info.maybe_reset()
            
            self.pre_processing()
            if (self.mode_next_id != _GM["DO_NOT_CHANGE"]):
                break

            self.flip_screen()
            self.clock.tick()
            self.debug_info.inc_frames()

            self.mid_processing()
            if (self.mode_next_id != _GM["DO_NOT_CHANGE"]):
                break

            self.process_players_input()
            if (self.mode_next_id != _GM["DO_NOT_CHANGE"]):
                break

            self.post_processing()

            
            self.frame_id += 1
    
            dt = pygame.time.get_ticks() - curtime
            if dt < min_time_per_frame:
                pygame.time.delay(min_time_per_frame - dt)

        #wait till threads finish
        self.threads_must_stop = True
        while self.n_threads > 0:
            time.sleep(0.1)


        self.post_session()
        return self.mode_next_id

    def start_thread(self, func, arg):
        self.n_threads += 1
        threading._start_new_thread(func, arg)

    def some_thread_stopped(self):
        self.n_threads -= 1

    def flip_screen(self):
        #prepare
        stor = self.stor
        dirty = self.stor.dirty


        #erase
        blit = stor.screen.blit
        back = stor.background
        old = dirty.old_dirty_rects
        for i in range(dirty.free_old):
            blit(back, old[i], old[i])

        #draw
        self.update_screen(True)
        pygame.display.update(dirty.new_dirty_rects[:dirty.free_new] + dirty.old_dirty_rects[:dirty.free_old] + dirty.new_unerase_rects[:dirty.free_unerase])

        #swap dirty rects
        dirty.post_frame()
        
########        print "showtime!"
########        def showtime(t0):
########            print time.time() - t0
########            return time.time()
######
########        t = time.time()
######        
######        #draw
######        self.update_screen(True)
########        t = showtime(t)
########        print "update:"       
######
########        print "drawing:"
########        print "\n".join([str(x) for x in dirty.new_dirty_rects[:dirty.free_new] + dirty.old_dirty_rects[:dirty.free_old] + dirty.new_unerase_rects[:dirty.free_unerase]])
######        
######        pygame.display.update(dirty.new_dirty_rects[:dirty.free_new] + dirty.old_dirty_rects[:dirty.free_old] + dirty.new_unerase_rects[:dirty.free_unerase])
########        t = showtime(t)
########        print "flip:"
#######        pygame.display.flip()
########        t = showtime(t)
########        print "\n"*5 + "Dirty rects:" + "\n:" * 5
########        print "\n".join([str(r) for r in dirty.new_dirty_rects])
######        dirty.post_frame() #moves new to old
########        t = showtime(t)
######        
########        t = showtime(t)
######        #erase
######        blit = stor.screen.blit
######        back = stor.background
######        old = dirty.old_dirty_rects
######        for i in range(dirty.free_old):
######            blit(back, old[i], old[i])
        

        
        
##########            stor = self.stor
##########            dirty = self.stor.dirty
##########
###########            screen = stor.screen
###########            screen.fill((0, 0, 0), screen.get_rect())
##########
##########            self.update_screen(True)
############            print "\n".join([str(dirty.new_dirty_rects[i]) for i in range(dirty.free_new)])
##########            pygame.display.update(dirty.new_dirty_rects + dirty.old_dirty_rects)

    def update_screen(self, visible):
        "virtual!!!"
        pass

    def process_players_input(self):
        "virtual!!!"
        pass

    def pre_processing(self):
        pass

    def mid_processing(self):
        pass

    def post_processing(self):
        pass

    def pre_session(self):
        pass
    
    def post_session(self):
        pass

    def init_place_mouse(self):
        pass
        
