from gm_dialog import gm_dialog
from vcg_option_list import vcg_option_list
from vcg_dialog import vcg_dialog
from vcg_entitled_board import vcg_entitled_board
from vc_button_text import vc_button_text
from img_list import img_list
import constants as c_

class vcg_1_player(vcg_dialog):
    def __init__(self, daddy, stor, handler):
        vcg_dialog.__init__(self, daddy, stor, handler)

    def add_items(self):
        vcg_dialog.add_items(self)

        brd = vcg_entitled_board(("Choose difficulty", 70, 20, 70),
                                 self, self.stor, self.handler,
                                 prc_area = (0, 18, 100, 64))
        self.items.append(brd)

        faces = img_list(self.stor.imgf, (c_._IG_DIFFIC, 0, 3))
        names = ("000Easiest",
                 "00Easy",
                 "C11L",
                 "Hard22",
                 "Hardest222")
        def format(s):
            for i in range(3):
                s = s.replace(str(i), faces[i].as_str())
            return "\\S(2.0, 1.0)\\" + s
       
        buttons = tuple([(str(i), format(names[i])) for i in range(5)])

                          
        self.optlist = vcg_option_list("OL_DIFFIC", buttons, brd, self.stor,
                                       self.handler, 
                                       arrng_proport = [15, 85],                
                                       init_choice_id = 0,
                                       reset_once = True
                                       )

        brd.board_items.append(self.optlist)

        self.items.append(vc_button_text("BTN_START", 13, self, "START", 90,
                                         prc_area = (75, 83, 22, 12),
                                         button_stretched = False))
        


class gm_1_player(gm_dialog):
    def __init__(self, stor):
        gm_dialog.__init__(self, stor)

    def create_gui(self):
        return vcg_1_player(self, self.stor, self)

    def handle_BTN_START_click(self):
        self.chat["DIFFICULTY"] = int(self.gui.optlist.selected.name)
        self.chat["NEWGAME"] = True
        self.mode_next_id = c_._GM["AI"]

