from gm_dialog import gm_dialog
from vcg_dialog import vcg_dialog
from img_holder import img_holder
from vis_comp import vis_comp
from vc_button_text import vc_button_text
import constants as c_
from vcg_msgboard import vcg_msgboard, vcg_msglist
from vcg_entitled_board import vcg_entitled_board
from vcg_board import vcg_board

N_STEPS = 7

class vcg_about_0(vcg_dialog):
    def add_items(self):
        vcg_dialog.add_items(self)
        self.items.append(vis_comp(self, img_holder(c_._IG_CREDITS, 0),
                                   RM = vis_comp._RM_BACKGROUND,
                                   prc_area = (0, 0, 100, 100)
                                   ))
        self.items.append(vc_button_text("BTN_NEXT", 13, self, "start", 90,
                                         prc_area = (35, 75, 22, 12),
                                         button_stretched = False))
                          
class vcg_about_1(vcg_dialog):
    def add_items(self):
        vcg_dialog.add_items(self)
        self.items.append(vis_comp(self, img_holder(c_._IG_CREDITS, 1),
                                   RM = vis_comp._RM_BACKGROUND,
                                   prc_area = (0, 0, 100, 100)
                                   ))
        self.items.append(vc_button_text("BTN_NEXT", 13, self, "next", 90,
                                         prc_area = (53, 70, 22, 12),
                                         button_stretched = False))
                          

class vcg_about_2(vcg_dialog):
    def add_items(self):
        vcg_dialog.add_items(self)

        b = vcg_entitled_board(("A huge thank you to...", 80, 18, 62),
                               self, self.stor, self.handler,
                               (1, 18, 98, 64))
        self.items.append(b)
                               

        messages = (("All friends and mates,", 60),
                    ("for their help and", 60),
                    ("support of all kinds", 60),
                    )
        msglist = vcg_msglist(messages, b, self.stor, self.handler,
                              (0, 0, 100, 100),
                              scale_text_sizes = False)
        b.board_items.append(msglist)

        self.items.append(vc_button_text("BTN_NEXT", 13, self, "next", 90,
                                         prc_area = (75, 83, 22, 12),
                                         button_stretched = False))

class vcg_about_3(vcg_dialog):
    def add_items(self):
        vcg_dialog.add_items(self)
        
##        messages = ("Google Summer Of Code 2005",
##                    "WinLibre project",
##                    "The Sneaky Snakes 1.0")
##        prc_area = (8, -1, 84, 40)
##        self.items.append(vcg_msgboard(messages, self, self.stor,
##                                       self.handler, prc_area,
##                                       board_img_id = 1))
        self.items.append(vcg_board(self, self.stor, self.handler,
                                    (8, 0, 52, 48),
                                    board_img_id = 2, alpha = 255))

        self.items.append(vcg_entitled_board(("MENTOR", 70, 27, 55),
                                             self, self.stor, self.handler,
                                             (62, 8, 34, 36),
                                             board_img_id = 3))
                                             

        def add_brd(name, messages, x_shift, arrng_proport,
                    logo_id, logo_prc_area):
            brd = vcg_entitled_board((name, 90, 20, 55),
                                     self, self.stor, self.handler,
                                     (x_shift, 48, 48, 50))
            self.items.append(brd)                           

            lst = vcg_msglist(messages, brd, self.stor, self.handler,
                              arrng_proport = arrng_proport)
            brd.board_items.append(lst)

            logo = vis_comp(brd, img_holder(c_._IG_LOGO, logo_id),
                            prc_area = logo_prc_area,
                            RM = vis_comp._RM_ON_CHANGE,
                            stretched = True)

            brd.items.append(logo)
            
        brd = add_brd("Code, music by",
                      ("Michael     ",
                       "Rybak       ",
                       "",
                       "\\S(0.7, 0.5)\\(accepted@ukr.net)"),
                      1, [28, 28, 14, 30],
                      0, (58, 40, 29, 30)
                      )
        
        brd = add_brd("Graphics by",
                      ("\\S(0.7, 0.5)\\    (11am@ukr.net)",
                       "",
                       "         Cate",
                       "     Zagorska"),
                      51, [30, 16, 28, 28],
                      1, (15, 48, 29, 30)
                      )
        
        

        self.items.append(vc_button_text("BTN_NEXT", 13, self, "next", 90,
                                         prc_area = (39, 88, 22, 12),
                                         button_stretched = False))

class vcg_about_4(vcg_dialog):
    def add_items(self):
        vcg_dialog.add_items(self)
        
        messages = ("Thank you Google",
                    "for this terrific event,",
                    "which brought as much",
                    "experience and excitement",
                    "in these 2 months,",
                    "as one can imagine.",
                    "",
                    "It has been",
                    "a huge inspiration",
                    "to our further activity",
                    )
        prc_area = (10, 10, 80, 80)
        self.items.append(vcg_msgboard(messages, self, self.stor,
                                       self.handler, prc_area))

        self.items.append(vc_button_text("BTN_NEXT", 13, self, "next", 90,
                                         prc_area = (77, 86, 22, 12),
                                         button_stretched = False))

class vcg_about_5(vcg_dialog):
    def add_items(self):
        vcg_dialog.add_items(self)
        
        messages = (("And the last 'thank you'", 60),
                    ("goes to ...", 60)
                    )
        prc_area = (0, 30, 100, 40)
        self.items.append(vcg_msgboard(messages, self, self.stor,
                                       self.handler, prc_area,
                                       scale_text_sizes = False))

        self.items.append(vc_button_text("BTN_NEXT", 13, self, "next", 90,
                                         prc_area = (75, 83, 22, 12),
                                         button_stretched = False))

class vcg_about_6(vcg_dialog):
    def add_items(self):
        vcg_dialog.add_items(self)

        b = vcg_entitled_board(("YOU!", 33, 40, 120),
                               self, self.stor, self.handler,
                               (1, 25, 98, 50))
        self.items.append(b)
                               

        messages = (("Thanks for playing! :)", 60),
                    )
        msglist = vcg_msglist(messages, b, self.stor, self.handler,
                              (0, 0, 100, 100),
                              scale_text_sizes = False)
        b.board_items.append(msglist)

        self.items.append(vc_button_text("BTN_NEXT", 13, self, "close", 90,
                                         prc_area = (75, 83, 22, 12),
                                         button_stretched = False))


class gm_about(gm_dialog):
    def __init__(self, stor):
        self.guis = []
        gm_dialog.__init__(self, stor)
        

    def create_gui(self):
        for i in range(N_STEPS):
            class_ = eval("vcg_about_%d" % i)
            self.guis.append(class_(self, self.stor, self))
        return self.guis[0]

    def pre_session(self):
        self.step = self.chat["STEP"]
        self.gui = self.guis[self.step]
        gm_dialog.pre_session(self)


    def handle_BTN_NEXT_click(self):
        if self.step == N_STEPS - 1:
            self.mode_next_id = c_._GM["MAIN_MENU"]
        else:
            self.mode_next_id = c_._GM["ABOUT"]
            self.chat["STEP"] = self.step + 1

    def handle_BTN_CLOSE_click(self):
        self.mode_next_id = c_._GM["MAIN_MENU"]

##from gm_dialog import gm_dialog
##from vcg_msgboard import vcg_msgboard
##from vcg_dialog import vcg_dialog
##
##class vcg_about(vcg_dialog):
##    def __init__(self, daddy, stor, handler):
##        vcg_dialog.__init__(self, daddy, stor, handler)
##
##    def add_items(self):
##        vcg_dialog.add_items(self)
##        
##        messages = ("Google Summer Of Code 2005",
##                    "WinLibre project",
##                    "The Sneaky Snakes (beta 0.3)",
##                    "",
##                    "by Michael Rybak",
##                    "accepted@ukr.net",
##                    "",
##                    "Graphics by KZ",
##                    "",
##                    "\\S(0.7,1.0)\\this dialog will soon contain credits",
##                    )
##        prc_area = (1, 1, 98, 98)
##        self.items.append(vcg_msgboard(messages, self, self.stor,
##                                       self.handler, prc_area))
##
##
##class gm_about(gm_dialog):
##    def __init__(self, stor):
##        gm_dialog.__init__(self, stor)
##
##    def create_gui(self):
##        return vcg_about(self, self.stor, self)
##
##print getattr("vcg_about_0")
