from game_mode import game_mode
import constants as c_
import pygame
from pygame.constants import KEYDOWN, KEYUP
import common_

class gm_dialog(game_mode):
    _MUSIC_ID = 0
    _PLAY_ONCE = False
    
    def __init__(self, stor):
        game_mode.__init__(self, stor)
        self.gui = self.create_gui()
        
        self.preserve_back_mode = c_._PRES_MODE_PREVIOUS_BACK
        self.forced_pb_mode = None
        self.sav_background = None
        self.darken_back = True
        
    def create_gui(self):
        "must create a vcg consisting of other vcg's"
        raise NotImplementedError

    def pre_session(self):
        self.stor.sndf.set_music(self._MUSIC_ID, play_once = self._PLAY_ONCE)
        self.set_background()
        self.gui.new_session()

    def set_background(self):
        self.sav_background = common_.copy_image(self.stor.background)

        if not (self.forced_pb_mode is None):
            self.preserve_back_mode = self.forced_pb_mode
        
        if self.preserve_back_mode == c_._PRES_MODE_PREVIOUS_SCREEN:
            #get previous
            c = pygame.Surface(self.stor.screen.get_rect().size)
            c.blit(self.stor.screen, (0, 0))
        else:
            assert(self.preserve_back_mode == c_._PRES_MODE_PREVIOUS_BACK)
            c = common_.copy_image(self.stor.background)

        if self.darken_back: #darken
            c.set_alpha(100)
        b = pygame.Surface(self.stor.screen.get_rect().size)
        b.blit(c, (0, 0))
        self.stor.background = b

    def post_session(self):
        self.stor.background = self.sav_background
        

    def update_screen(self, visible):
        self.gui.render()

    def process_players_input(self):
        mouse_pos = pygame.mouse.get_pos()
        mouse_pressed = pygame.mouse.get_pressed()
        
        self.gui.mouse_is_moving(mouse_pos)
        self.gui.mouse_is_pressed(mouse_pressed, mouse_pos)


        for e in pygame.event.get([KEYDOWN, KEYUP]):
            if e.type == KEYDOWN:
                self.gui.on_key_down(e.key)
            else:
                self.gui.on_key_up(e.key)
##        for e in pygame.event.get([KEYDOWN]):
##            print "key_press: %s" % e.key
##            if e.key == 27:
##                self.key_pressed_ESC()
        pygame.event.clear()
        pygame.event.pump()

        
    def handle_BTN_CLOSE_click(self):
        self.mode_next_id = c_._GM["SET_TO_PREVIOUS"]

        
        

##import pygame
##import types
##
##from game_mode import game_mode
##from common_ import *
##import constants as c_
##from snd_holder import snd_holder
##
##class gm_dialog(game_mode):
##
##    def __init__(self, i_storage):
##        game_mode.__init__(self, i_storage)
##        self.dy = 10
##        self.items = []
##        self.text = []
##        self.text_pos = []
##        self.preserve_back_mode = c_._PRES_MODE_PREVIOUS_SCREEN
##        self.forced_pb_mode = None
##        self.do_click_sound = True
##
##        self.sh_click = snd_holder(c_._SG_CLICKS, 0)
##        self.sound = None
##
##    def pre_session(self):
##        if "FROM_MM" in self.chat.keys():
##            self.preserve_back_mode = c_._PRES_MODE_PREVIOUS_SCREEN
##            del self.chat["FROM_MM"]
##        else:
##            self.preserve_back_mode = c_._PRES_MODE_PREVIOUS_BACK
##
##        if not (self.forced_pb_mode is None):
##            #we do this check AFTER we've set a a state, because
##            #we need to del self.chat["FROM_MM"] anyway
##            self.preserve_back_mode = self.forced_pb_mode
##        
##        if self.preserve_back_mode == c_._PRES_MODE_PREVIOUS_SCREEN:
##            #get previous
##            c = pygame.Surface(self.stor.screen.get_rect().size)
##            c.blit(self.stor.screen, (0, 0))
##            c.set_alpha(100)
##            #darken
##            b = pygame.Surface(self.stor.screen.get_rect().size)
##            b.blit(c, (0, 0))
##            self.stor.background = b
##        else:
##            assert(self.preserve_back_mode == c_._PRES_MODE_PREVIOUS_BACK)
##            pass
##
##    def update_screen(self, visible):
##        rend_text = self.stor.imgf.rend_text
##        screen = self.stor.screen
##        scrx =  screen.get_rect().width
##        scry =  screen.get_rect().height
##
##        text = []
##        text_pos = []
##        ##render all
##        for item in self.items:
##            text_cur, text_pos_cur = rend_text(item.cap, (255, 255, 255), item.font_size)
##            
##            text.append(text_cur);
##            text_pos.append(text_pos_cur)
##            
##        #find an y coord to put menu items at
##        total_y = -self.dy;
##        for it in text_pos:
##            total_y = total_y + it.height + self.dy
##        y0 = (scry - total_y) / 2
##
##
##        #draw all
##        y = y0    
##        for i in range(len(text)):
##            text_ = text[i]
##            text_pos_ = text_pos[i]
##            text_pos_.centerx = scrx / 2
##            text_pos_.top = y
##            blit_(self.stor, text_, text_pos_, visible) 
##            y += text_pos_.height + self.dy
##
##        self.text = text[:]
##        self.text_pos = text_pos[:]
##
##    def process_players_input(self):
##        have_key = False
##        for e in pygame.event.get():
##            if e.type == pygame.KEYDOWN:
##                have_key = True
##                break
##
##        if have_key:
##            print "key_press: %s" % e.key
##
##            sounded = False
##            for it in self.items:
##                ret = it.di_key_press(e.key)
##                if ret != None:
##                    if (self.do_click_sound and (not sounded)):
##                        self.sound = self.stor.sndf.get_sound(self.sh_click)
##                        sounded = True
##                    self.dlg_key_press(ret)
##
##        pygame.event.clear(pygame.KEYDOWN)
##
##    def dlg_key_press(self, di_return_id):
##        pass        
##        
##
##class dialog_item:
##
##    def __init__(self, cap, data, font_size = 32):
##        self.cap = cap
##        self.data = data #optional and specific to item type
##        self.font_size = font_size
##
##    def on_key_press(self):
##        pass
##
##class di_simple(dialog_item):
##    
##    def  __init__(self, cap, data, return_id = 0, key = 0, font_size = 32, event_func = None):
##        dialog_item.__init__(self, cap, data, font_size)
##        self.return_id = return_id
##        self.key = key
##        self.event_func  = event_func
##
##    def di_key_press(self, key):
##        
##        if callable(self.event_func):
##            self.event_func(key)
##
##        if type(self.key) == types.IntType: #single value
##            our_key = (self.key == key)
##        else:                               #list of keys
##            our_key = self.key.count(key) > 0
##            
##        if our_key:
##            return self.return_id
##        else:
##            return None
