from gm_dialog import gm_dialog
from vcg_entitled_board import vcg_entitled_board
from vcg_dialog import vcg_dialog
from vc_label import vc_label
from vis_comp import vis_comp
from img_list import img_list
import constants as c_
from snd_holder import snd_holder

class vcg_game_over(vcg_dialog):
    def __init__(self, daddy, stor, handler):
        vcg_dialog.__init__(self, daddy, stor, handler)

    def add_items(self):
##        print "adding items to vcg_game_over"
        vcg_dialog.add_items(self)

        self.my_board = vcg_entitled_board(("GAME OVER", 60, 25, 70), self, self.stor,
                                           self.handler,
                                           prc_area = (15, 17, 70, 66))
        self.items.append(self.my_board)


        self.pic_result = vis_comp(self, img_list(self.imgf,
                                                  autoload = (c_._IG_GAME_OVER,
                                                              0, 6)
                                                  ),
                                   prc_area = (0, 0, 100, 80),
                                   stretched = True)
        self.lbl_result = vc_label(self, "Will place game's result here", 60, 
                                   prc_area = (0, 80, 100, 20),)
                                   
        self.my_board.board_items.extend([self.pic_result, self.lbl_result])

        #make more transparent
        ih = self.my_board.back_pic.img_list[0]
        self.imgf.groups[ih.img_gr][ih.img_id].img[0].set_alpha(80)

    def new_session(self):
        self.lbl_result.change_text(self.daddy.result)
        self.pic_result.img_list.init_id = self.daddy.res_pic_id

        vcg_dialog.new_session(self)
    
class gm_game_over(gm_dialog):
    _SH_GAME_OVER = snd_holder(c_._SG_MISC, 0)
    _MUSIC_ID = 2
    _PLAY_ONCE = True
    
    def __init__(self, stor):
        gm_dialog.__init__(self, stor)
        self.forced_pb_mode = c_._PRES_MODE_PREVIOUS_SCREEN
        self.darken_back = False
        
        self.sh_game_over = self._SH_GAME_OVER
        self.now_sound = None

    def pre_session(self):
        self.result, self.res_pic_id = self.chat["RESULT"]
        gm_dialog.pre_session(self)

##        self.now_sound = self.stor.sndf.get_sound(self.sh_game_over)

    def post_session(self):
        if self.now_sound:
            self.now_sound.stop()
        gm_dialog.post_session(self)
        
    def create_gui(self):
        return vcg_game_over(self, self.stor, self)

    def handle_BTN_CLOSE_click(self):
        self.mode_next_id = c_._GM["MAIN_MENU"]        
