from game_mode import game_mode
from common_ import *
from img_holder import img_holder
from snd_holder import snd_holder
import constants as c_

class gm_howto(game_mode):
    def __init__(self, stor):
        game_mode.__init__(self, stor)
        self.active_id = None
        self.active_changed = True
        self.masks = [self.stor.imgf.get_image(img_holder(c_._IG_HOWTO, i + 1)).img[0] for i in range(4)]

        self.sh_active = snd_holder(c_._SG_BTN, 0)
        self.sh_click = snd_holder(c_._SG_BTN, 1)
        self.sound = None

    def pre_session(self):
        b = pygame.Surface(self.stor.screen.get_rect().size)
        img = self.stor.imgf.get_image(img_holder(c_._IG_HOWTO, 0))
        b.blit(img.img[0], (0, 0))
        self.stor.background = b

        self.active_id_changed = True
        self.active_id = None
        
        

 
    def update_screen(self, visible):
        if not self.active_changed:
            return
        if not visible:
            return

        b = self.stor.background
        blit_unerase(self.stor, b, b.get_rect(), visible)
        if not (self.active_id is None):
            ih = img_holder(c_._IG_HOWTO, self.active_id + 1)
            img = self.stor.imgf.get_image(ih)
            blit_unerase(self.stor, img.img[0], img.img[1], visible)

    def process_players_input(self):
        pos = pygame.mouse.get_pos()
        old_active = self.active_id
        self.active_id = None
####        for m in self.masks:
####            cl = m.get_at(pos)
######            cl = (255,255,255,255)
####            if cl[0] + cl[1] + cl[2] != 255 * 3:
####                self.active_id = self.masks.index(m)
        scr = self.stor.screen.get_rect().size
        x, y = (float(pos[0]) / scr[0]) - 0.5, (float(pos[1]) / scr[1]) - 0.5
        bnd = 0.05
        if ((x > bnd) and (y < -bnd)):
            self.active_id = 0
        elif ((x < -bnd) and (y > bnd)):
            self.active_id = 1
        elif ((x > bnd) and (y > bnd)):
            self.active_id = 2
        elif ((x < -bnd) and (y < -bnd)):
            self.active_id = 3
        
        self.active_changed = self.active_id != old_active
        if self.active_changed and (self.active_id != None):
            self.sound = self.stor.sndf.get_sound(self.sh_active)


        do_exit = False
        for e in pygame.event.get([KEYDOWN]):
            if e.key == 27:
                do_exit = True
                break
        for e in pygame.event.get([MOUSEBUTTONDOWN]):
            if e.button == 1:
                do_exit = True
                break
                
        if do_exit:
            self.sound = self.stor.sndf.get_sound(self.sh_click)
            self.mode_next_id = c_._GM["MAIN_MENU"]

            
        pygame.event.clear()
        pygame.event.pump()

