import pygame
from game_mode import game_mode
from pygame.constants import *
import constants as c_
from img_holder import img_holder
from snd_holder import snd_holder
from common_ import *
import threading
import time
import constants as c_

_MM_HOTKEYS = ([], [], [], [], [], [K_ESCAPE])
_MM_ACTIONS = ("1PLAYER", "2PLAYERS", "SOUND", "HOWTO", "ABOUT", "EXIT")
_MM_LEFT_TOP = ((37, 13), (485, 37), (452, 238),
                (164, 214), (152, 594), (515, 513))
_MM_REL_CENTER = ((210, 110), (217, 113), (223, 151),
                  (167, 251), (159, 109), (217, 159))
_MM_TEXT = (c_._IG_S_1_PLAYER,
            c_._IG_S_2_PLAYERS,
            c_._IG_S_SOUND_ON,
            c_._IG_S_HOWTO,
            c_._IG_S_CREDITS,
            c_._IG_S_EXIT,
            )
_MM_HOWTO_TEXT_2 = c_._IG_S_PLAY
_MM_SOUND_TEXT_2 = c_._IG_S_SOUND_OFF
_MM_ANGLE = (12, -16, 0, 8, -6, 12)
_MM_BUTTON_SHIFT = (4, 4)

_ANIM_SPEED = 30 #alpha blending

class item:
    def __init__(self, menu, stor, id):
        mm_img_id = id + 1
        
        self.id = id
        self.menu = menu
        self.stor = stor
        self.ih = img_holder(c_._IG_MAIN_MENU, mm_img_id)
        self.mask = self.stor.imgf.get_image(self.ih).img[0]
        self.f_action = getattr(self, "action" + _MM_ACTIONS[id])
        self.alpha = 0
        self.incr_alpha = -1
        self.text_id = _MM_TEXT[self.id]
        self.text_angle = _MM_ANGLE[self.id]
        self.sh_active = snd_holder(c_._SG_BTN, 0)
        self.sh_click = snd_holder(c_._SG_BTN, 1)
        self.sound = None

        self.set_coords()

    def set_coords(self):
        scl = self.stor.imgf.main_menu_scale
        lt = _MM_LEFT_TOP[self.id]
        c = _MM_REL_CENTER[self.id]
        sh = _MM_BUTTON_SHIFT
        self.left_top = tuple([int(scl[i] * lt[i]) for i in range(2)])
        self.center = tuple([int(scl[i] * (c[i] + lt[i])) for i in range(2)])
        self.button_shift = tuple([int(scl[i] * sh[i]) for i in range(2)])

    def render(self, visible):
        img = self.stor.imgf.get_image_alpha(self.ih, alpha = self.alpha)
        rect = img.img[1]
        rect.topleft = self.left_top
##        blit_unerase(self.stor, img.img[0], rect, False)
        blit_(self.stor, img.img[0], rect, visible)
        self.render_text(visible, self.text_id)

    def render_text(self, visible, text_id, shift = (0, 0)):
        img = self.stor.imgf.get_image_alpha(img_holder(c_._IG_STRINGS, text_id),
                                             angle = self.text_angle)
        w = img.img[1].height
        p = map(lambda x, y: x + y * w, self.center, shift)
        rect = img.img[1]
        rect.center = p
        img.img[0].set_alpha(None)
        blit_unerase(self.stor, img.img[0], rect, visible)
        img.img[0].set_alpha(self.alpha)
        blit_unerase(self.stor, img.img[0], rect.move(self.button_shift), visible)
        

    def hotkeys(self):
        return _MM_HOTKEYS[self.id]

    def action(self, gm):
        self.sound = self.stor.sndf.get_sound(self.sh_click)
        self.f_action(gm)
        
    def actionNONE(self, gm):
        return

    def action1PLAYER(self, gm):
##        return
        gm.mode_next_id = c_._GM["1_PLAYER"]

    def action2PLAYERS(self, gm):
        gm.mode_next_id = c_._GM["2_PLAYERS"]

    def actionSOUND(self, gm):
        gm.mode_next_id = c_._GM["SETTINGS"]
##        if self.text_id == _MM_SOUND_TEXT_2:
##            self.text_id = _MM_TEXT[self.id]
##            self.stor.settings.sound = True
##            self.sound = self.stor.sndf.get_sound(self.sh_click)
##        else:
##            self.text_id = _MM_SOUND_TEXT_2
##            self.stor.settings.sound = False
##            if self.sound:
##                if self.sound.get_busy():
##                    self.sound.fadeout(200)
        
    def actionABOUT(self, gm):
        gm.mode_next_id = c_._GM["ABOUT"]
        gm.chat["STEP"] = 0

##        gm.mode_next_id = c_._GM["GAME_OVER"]  #debug
##        gm.chat["RESULT"] = ("PLAYER 1 WINS", 1)
        
    def actionHOWTO(self, gm):
        gm.mode_next_id = c_._GM["HOWTO"]
        
    def actionEXIT(self, gm):
        if self.sound:
            if self.sound.get_busy():
                time.sleep(0.1)
                self.sound.fadeout(200)
                time.sleep(0.2)
        gm.mode_next_id = c_._GM["END"]

    def gets_mouse(self, pos):
        a = self.left_top
        pos = (pos[0] - a[0], pos[1] - a[1])
        try:
            return self.mask.get_at(pos)[1] != 0 #green component
        except:
            return False

    def make_active_item(self):
        menu = self.menu
        if menu.active_item:
            menu.active_item.incr_alpha = -1
        self.incr_alpha = 1
        self.alpha = 255
        self.sound = self.stor.sndf.get_sound(self.sh_active)
        menu.active_item = self

class item_howto(item):
    def __init__(self, menu, stor, id):
        item.__init__(self, menu, stor, id)
        self.text2_id = _MM_HOWTO_TEXT_2
        
    def render_text(self, visible, text_id, shift = (0, 0)):
        item.render_text(self, visible, text_id, shift = (0, -0.35))
        item.render_text(self, visible, self.text2_id, shift = (0, 0.35))
        
class gm_main_menu(game_mode):
    def __init__(self, stor):
        game_mode.__init__(self, stor)

        #create items
        self.items = []
        self.items.append(item(self, stor, 0))
        self.items.append(item(self, stor, 1))
        self.items.append(item(self, stor, 2))
        self.items.append(item_howto(self, stor, 3))
        self.items.append(item(self, stor, 4))
        self.items.append(item(self, stor, 5))

        self.items_lock = threading.Lock()

        self.active_item = None
            
    def thr_anim(self):
        delta = 0.04
        while 1:
##            self.items_lock.acquire()
            for it in self.items:
                a = it.alpha + it.incr_alpha * _ANIM_SPEED
                if a < 0: a = 0
                if a > 255: a = 255
                it.alpha = a
##            self.items_lock.release()

            time.sleep(delta)
            if self.threads_must_stop:
                break
        self.some_thread_stopped()
        
    def update_screen(self, visible):
        if not visible:
            self.stor.screen.blit(self.stor.background, (0, 0))
            return
        self.items_lock.acquire()

        for it in self.items:
            it.render(visible)
        
        self.items_lock.release()

    def pre_session(self):
        self.stor.sndf.set_music(0)

        #background
        b = pygame.Surface(self.stor.screen.get_rect().size)
        img = self.stor.imgf.get_image(img_holder(c_._IG_MAIN_MENU, 0))
        b.blit(img.img[0], (0, 0))
        self.stor.background = b

        #start threads
        self.start_thread(self.thr_anim, ())

    def process_players_input(self):
        ek = pygame.event.get([KEYDOWN])
        emb = pygame.event.get([MOUSEBUTTONDOWN])

        pygame.event.clear()
        pygame.event.pump()
        
        for e in ek:
            print e.key
            for it in self.items:
                if e.key in it.hotkeys():
                    it.action(self)

        pos = pygame.mouse.get_pos()
        for it in self.items:
            if it is not self.active_item:
                if it.gets_mouse(pos):
##                    self.items_lock.acquire()
##                    print "yes to", it.id
                    it.make_active_item()


        if self.active_item:
            if not self.active_item.gets_mouse(pos):
                self.active_item.incr_alpha = -1
                self.active_item = None
                

        for e in emb:
            if e.button == 1:
                if self.active_item:
                    self.active_item.action(self)
            
##                    self.items_lock.release()
                
