from gm_playing import gm_playing
from comm_interface import comm_interface
import constants as c_
import pygame
from pygame.constants import *
from net_storage import net_storage
from common_ import print_
import cloud

class gm_network(gm_playing):
    def __init__(self, i_storage):
        gm_playing.__init__(self, i_storage)
        self.file = None
        self.net_stor = None

    def assign_players_me_he(self):
        "virtual; set p_me and p_he here"
        raise NotImplementedError

    def send_first(self):
        "virtual; see net_storage.thr_io"
        raise NotImplementedError

    def get_events_from_net_stor(self):
        raise NotImplementedError

    def get_cloud_dxy_from_net_stor(self):
        raise NotImplementedError

    def get_ci_1(self):
        return comm_interface #we get opponent's info from net_storage

    def get_ci_2(self):
        return comm_interface #we get opponent's info from net_storage

    def pre_session(self):
        ns = net_storage(self, self.stor.sock)
        self.stor.net_storage = ns
        self.net_stor = ns

        gm_playing.pre_session(self)
        self.assign_players_me_he()
##        self.file = file("net.log", "w")

        self.start_thread(ns.thr_io, ())

    def post_session(self):
        gm_playing.post_session(self)
        self.stor.sock.close()
##        if self.file: self.file.close()
        
        self.stor.net_storage = None
        self.net_storage = None

    def post_processing(self):
        self.net_stor.exchange()
        self.post_exchange()

        self.handle_players_input()
        
        gm_playing.post_processing(self)


    def process_players_input(self):
        #get put my input and put to net_storage - done in ci_network
##        print_( "getting input from %s" % self.p_me)
        self.net_stor.my_out_lock.acquire()
        self.net_stor.my_out_vals.user_data = self.get_player_input(self.p_me)
        self.net_stor.my_out_lock.release()
##        print_( "set my vals: %s" % self.net_stor.my_out_vals.user_data)

        pygame.event.clear([KEYDOWN, KEYUP])

    def handle_players_input(self):
        """in networking mode we separate getting and handling;
        get -> exchange -> handle,
        so 1 frame less latency"""
        self.handle_player_input(self.p_me, self.net_stor.my_in_vals.user_data)
        self.handle_player_input(self.p_he, self.net_stor.his_in_vals.user_data)

    def post_exchange(self):
        cloud.post_exchange(self.stor, self.get_cloud_dxy_from_net_stor())

        #convert events into tuples
        raw_e = self.get_events_from_net_stor()
        for i in range(len(raw_e) / 3):
            j = i * 3
            gm_playing.new_event(self, raw_e[j], (raw_e[j + 1], raw_e[j + 2]))
##            print_( "read event: %d, %d, %d" % tuple(raw_e[j: j + 3]) )
            
