from gm_playing import gm_playing
from ci_server_waiting import ci_server_waiting
from icon import icon
from animation import animation
import constants as c_
from udp_server import udp_server

class gm_server_waiting_for_p2(gm_playing):

    def __init__(self, i_storage):
        gm_playing.__init__(self, i_storage)

        self.add_message()

    def get_ci_1(self):
        return self.stor.settings.get_main_ci()

    def get_ci_2(self):
        return ci_server_waiting

    def post_session(self):
        gm_playing.post_session(self)
        
        self.udp_server.close()
            
        #we either move to MainMenu or to ServerGame
        #in former case socket needs to be closed
        if self.mode_next_id == c_._GM["MAIN_MENU"]:
            self.stor.sock.close()

    def update_screen(self, visible):
        gm_playing.update_screen(self, visible)
        self.msg_waiting.render(visible)

    def add_message(self):
        self.msg_waiting = icon(self.stor, self.stor.screen.get_rect())
        img_id = c_._IG_S_WAITING_FOR_OPPONENT
        self.msg_waiting_anim = animation(
                          self.stor, self.msg_waiting.ih, c_._IG_STRINGS,
                          img_id, img_id + 1, "1212", delays = [1, 0.3], autorun = False)
         #autorun is False because to start animation we need a processlist,
         #which is created only when game starts


    def pre_session(self):
        self.udp_server = udp_server(str(self.stor.settings.server_icon))
        if not self.udp_server.is_bind:
            print "cannot start broadcasting at UDP server"
            self.mode_next_id = c_._GM["SET_TO_PREVIOUS"]
        else:
            gm_playing.pre_session(self)

    def start_new_game(self):
        gm_playing.start_new_game(self)
        self.msg_waiting_anim.start()

        self.stor.p1.char.is_damagable = False
        self.stor.p2.char.is_damagable = False

    def post_processing(self):
        gm_playing.post_processing(self)

        self.udp_server.listen_and_response()

    def handle_request_CLIENT_CONNECTED(self, player = None):
        self.mode_next_id = c_._GM["SERVER"]
        self.chat["NEWGAME"] = True

