from gm_dialog import gm_dialog
from vcg_option_list import vcg_option_list
from vcg_dialog import vcg_dialog
import constants as c_
from pygame.constants import K_1, K_2, K_3, K_ESCAPE
from vcg_entitled_board import vcg_entitled_board

class vcg_settings(vcg_dialog):
    def __init__(self, daddy, stor, handler):
        self.now_in_new_session = False
        vcg_dialog.__init__(self, daddy, stor, handler)

    def add_items(self):
        vcg_dialog.add_items(self)

        def add_sfx_mus_brd(name, x_shift, init_choice, kill_snd = False):
            brd = vcg_entitled_board((name, len(name) * 15, 14, 60),
                                      self, self.stor, self.handler,
                                      (x_shift, 5, 30, 90))
            self.items.append(brd)

            buttons = tuple([(str(i), str(i)) for i in range(10, 0, -1)]) + (("0", "OFF"),)
            lst = vcg_option_list("OL_" + name, buttons, brd,
                                  self.stor, self, 
                                  scale_text_sizes = True,
                                  arrng_proport = [30, 70],
                                  init_choice_id = init_choice,
                                  reset_once = True,
                                  report_only_new_values = False)

            if kill_snd:
                for button in lst.buttons:
                    button.do_sound = button.do_sound_not1 # we need to cheat here
                                                         # to sound AFTER user clicks
            
            brd.board_items.append(lst)
            return lst


        self.sfx = add_sfx_mus_brd("SFX", 10, 10 - c_._DEF_SFX_VOL, kill_snd = True)
        self.mus = add_sfx_mus_brd("MUSIC", 60, 10 - c_._DEF_MUS_VOL)

    def handle_OL_SFX_value_changed(self, btn):
        self.stor.settings.glob_sfx_vol_changed(int(btn.name))
        if not self.now_in_new_session:
            btn.do_sound_(1)

    def handle_OL_MUSIC_value_changed(self, btn):
        self.stor.settings.glob_mus_vol_changed(int(btn.name))

    def new_session(self):
        self.now_in_new_session = True
        vcg_dialog.new_session(self)
        self.now_in_new_session = False

class gm_settings(gm_dialog):
    def __init__(self, stor):
        gm_dialog.__init__(self, stor)

    def create_gui(self):
        return vcg_settings(self, self.stor, self)

        


