from gm_dialog import gm_dialog
from vcg_msgboard import vcg_msgboard
from vcg_dialog import vcg_dialog
from vc_button_text import vc_button_text
from vcg_option_list import vcg_option_list
from vcg_entitled_board import vcg_entitled_board
from vcg_scroll import vcg_scroll
from pygame.constants import K_RETURN, K_ESCAPE
from img_holder import img_holder
import constants as c_

class vcg_start_server(vcg_dialog):
    def __init__(self, daddy, stor, handler):
        vcg_dialog.__init__(self, daddy, stor, handler)
        self.btn_exit.hotkeys = (K_ESCAPE,) #excluded K_RETURN

    def add_items(self):
        vcg_dialog.add_items(self)

        add = self.items.append

        add(vcg_msgboard((("Start multiplayer", 60),),
                         self, self.stor, self.handler,
                         prc_area = (15, 5, 70, 20), board_img_id = 1))

        add(vc_button_text("BTN_START", K_RETURN, self, "Start", 80, 
                           prc_area = (80, 80, 15, 15)))

        board = vcg_entitled_board(("Choose a server icon", 70, 30, 60),
                                   self, self.stor, self.handler,
                                   prc_area = (2, 35, 96, 45))
        add(board)


        def icon_str(i):
            scale_flag = "\\S(1.0, 0.5)\\"
            hyperchar = img_holder(c_._IG_SERVER_ICONS, i).as_str()
            return scale_flag + hyperchar
        server_icons = tuple([(str(i), icon_str(i))                               
                              for i in range(c_._IG_SZ_SERVER_ICONS)])
        icons = vcg_option_list("OL1", server_icons, board, self.stor, self.handler,
                                prc_area = (0, 0, 100, 100),
                                arrangement = "HORIZONTAL",
                                init_choice_id = 0,
                                reset_once = True)
        self.icons = icons
        board.board_items.append(icons)



class gm_start_server(gm_dialog):
    def __init__(self, stor):
        gm_dialog.__init__(self, stor)

    def create_gui(self):
        return vcg_start_server(self, self.stor, self)

    def handle_BTN_START_click(self):
        print "attempting to start server"
        self.stor.settings.server_icon = int(self.gui.icons.selected.name)
        self.mode_next_id = c_._GM["SERVER_WAITING_FOR_P2"]

    def handle_SCRB0_value_changed(self, new_val):
        print "scrollbar value:", new_val 
