import time
from random import random

class animation:
    def __init__(self, stor, daddy, img_gr, id_from, id_to, order_mode,
                 delay = None, delays = None, autorun = True):
        """
        daddy is some img_holder
        Possible order' modes:
            "AM_123"
            "AM_12321"

        You can either set:
            Delay: a delay after each frame
            Delays: a list of delays after each frame
        """
#        print "add anim!"
        self.stor = stor
        self.daddy = daddy
        self.img_gr = img_gr
        self.id_from = id_from
        self.id_to = id_to
        self.f_next_frame = getattr(self, "next_frame_AM_%s" % order_mode)

        self.time = None
        self.cur = None
        self.n = self.id_to - self.id_from
        self.incr = 1
        self.playing = False
        
        if (delay and delays):
            raise "you should either set a common delay or separate delay for each image"

        if (delay):
            delays = [delay for i in range(self.n + 1)]

        self.delays = delays

        
        if autorun:
            self.start()

    def start(self, first = 0):
#        print "animation starts!"
        self.time = 0
        self.realtime = time.time()
        self.stor.process_list.append(self.on_event)
        self.cur = first
        self.incr = 1
        self.playing = True

    def stop(self, next_ih = None):
        self.stor.process_list.remove(self.on_event)
        self.playing = False
        if next_ih != None:
            self.daddy.img_gr = next_ih.img_gr
            self.daddy.img_id = next_ih.img_id
            

    def on_event(self, dt):
#        print "dt = %s" % dt
        self.time += time.time() - self.realtime
        self.realtime = time.time()
#        print "cur  : %s" % self.cur
#        print "time : %s" % self.time
#        print "delay: %s" % self.delays[self.cur]
#        print self.delays[self.cur]
        while self.time >= self.delays[self.cur]:
            self.time -= self.delays[self.cur]
            self.f_next_frame()
#            print "**time : %s" % self.time
#            print "**delay: %s" % self.delays[self.cur]
        self.update_daddy()

    def update_daddy(self):
        self.daddy.img_gr = self.img_gr
        self.daddy.img_id = self.cur + self.id_from
#        print self.cur

    def next_frame_AM_12321(self):
        c, i, n = self.cur, self.incr, self.n
        if (c + i < 0) or (c + i > n): i = -i
        self.cur, self.incr = c + i, i

    def next_frame_AM_1212(self):
        c, i, n = self.cur, self.incr, self.n
        if c + i > n: c = -1
        self.cur, self.incr = c + i, i


class anim_rnd_pause(animation):
    def __init__(self, stor, daddy, img_gr, id_from, id_to,
                 delay = None, delays = None, autorun = True,
                 min_pause = None, max_pause = None
                 ):
        order_mode = "12321_RND_PAUSE"
        animation.__init__(self, stor, daddy, img_gr, id_from, id_to,
                           order_mode, delay, delays, autorun)
        if min_pause == None:
            min_pause = self.delays[0]
            max_pause = self.delays[1]
        self.min_pause = min_pause
        self.max_pause = max_pause
        
    def next_frame_AM_12321_RND_PAUSE(self):
        c, i, n = self.cur, self.incr, self.n
        if (c + i < 0) or (c + i > n): i = -i
        self.cur, self.incr = c + i, i
        if self.cur == 0:
            self.delays[0] = self.min_pause + (self.max_pause - self.min_pause) * random()
        
        
        
 
    
