from vis_comp import vis_comp
from img_list import img_list
from img_holder import img_holder
import constants as c_

_IG = c_._IG_STRINGS_ON_THE_FLY

class vc_label(vis_comp):
    _DONT_CHANGE = -1
    def __init__(self, group, text, size, alpha = None, prc_area = None):
        "if dynamic, text is rerendered every frame, because it may change"
        self.imgf = group.imgf
        ih = self.pre_render_text(text, size, alpha, _IG)
        vis_comp.__init__(self, group, ih, prc_area = prc_area,
                          RM = vis_comp._RM_ON_CHANGE)
        

    def pre_render_text(self, text, size, alpha, img_gr):
        """pre_render_text(self, text, size, alpha, img_gr)

        renders given text and appends to imgf.groups[img_gr] """

        self.text, self.size, self.alpha = text, size, alpha
        self.text_img_id, self.img_gr = len(self.imgf.groups[img_gr]), img_gr

        return self.re_render_text()

    def re_render_text(self):
        n = self.text_img_id
        self.imgf.render_given_string(self.img_gr, n,
                                      self.text, self.size, self.alpha)
        return img_holder(self.img_gr, n)

    def change_text(self,
                    text = _DONT_CHANGE,
                    size = _DONT_CHANGE,
                    alpha = _DONT_CHANGE):
        "pass _DONT_CHANGE for a value to keep it"
        old_v = (self.text, self.size, self.alpha)
        
        if text   != self._DONT_CHANGE: self.text = text
        if size   != self._DONT_CHANGE: self.size = size
        if alpha  != self._DONT_CHANGE: self.alpha = alpha
        
        new_v = (self.text, self.size, self.alpha)

        changed = False
        for i in range(3):
            if old_v[i] != new_v[i]:
                changed = True
                break

        if changed:
            self.re_render_text()
            self.text_changed = True
            self.img_list.active_changed = True
        
