from vis_comp_group import vis_comp_group
from vis_comp import vis_comp
from vc_button_text import vc_button_text
from pygame import Rect
from pygame.constants import K_ESCAPE, K_RETURN
from img_holder import img_holder
import constants as c_
import common_
import my_maths

_CHILD_AREA = ((20, 15, 59, 72),
               (10, 10, 80, 80),
               (10, 10, 80, 80),
               (10, 10, 80, 80),
               )

class vcg_board(vis_comp_group):
    def __init__(self, daddy, stor, handler, prc_area, board_img_id = 0,
                 alpha = "DONT CHANGE"):
        self.imgf = stor.imgf
        self.original_img_id = board_img_id
        self.duplicate_msgbox_image(alpha)

        self.my_items = []
        vis_comp_group.__init__(self, daddy, stor, handler, prc_area)

    def duplicate_msgbox_image(self, alpha):
        """
        must add a new image to imgf to have myself a separate box
        need to copy from img_holder(c_._IG_MSGBOX, 0)"""
        
        self.img_id = self.imgf.duplicate_image(c_._IG_MSGBOXES,
                                                self.original_img_id).img_id
        if alpha != "DONT CHANGE":
            img = self.imgf.groups[c_._IG_MSGBOXES][self.img_id].img[0]
            img.set_alpha(alpha)
            img.convert_alpha()
                                     
        

    def add_items(self):
        self.back_pic = vis_comp(self,
                                 img_holder(c_._IG_MSGBOXES, self.img_id),
                                 RM = vis_comp._RM_BACKGROUND,
                                 prc_area = (0, 0, 100, 100),
                                 stretched = True
                                 )

        self.items.append(self.back_pic)
        self.my_items.append(self.back_pic)
        
        self.board_items = self.items

    def set_items_areas_CHILDREN(self):
        "reduce daddy's area for not my native children"
        self.child_area = my_maths.calc_prc_area(self.area,
                                                 _CHILD_AREA[self.original_img_id])
        for it in [it for it in self.items if it not in self.my_items]:
            it.get_daddy_area = (lambda : self.child_area)

        vis_comp_group.set_items_areas_CHILDREN(self)



    def get_font_size(self, n):
        return int(float(self.child_area.height) / (n + 1) / self.imgf.scale[1])

##    def render(self):
##        print "i am", self
##        print "rendering my items:", self.board_items
##        vis_comp_group.render(self)
        
