from vis_comp_group import vis_comp_group, arr_id
from vis_comp import vis_comp

from vc_button_text import vc_button_text
    
class vcg_btnlist(vis_comp_group):
    
    def __init__(self, buttons, daddy, stor, handler, prc_area,
                 scale_text_sizes = False, arrangement = "VERTICAL",
                 RM = vis_comp._RM_ON_CHANGE):
        self.scale_text_sizes = scale_text_sizes        
        self.buttons = buttons
        self.RM = RM
        vis_comp_group.__init__(self, daddy, stor, handler, prc_area, "SPECIAL")
        self.real_set_items_areas = getattr(vis_comp_group, "set_items_areas_%s" % arrangement)
        self.real_arr = arrangement


    def add_items(self):
        prev_size = 1

        for b in [list(b) for b in self.buttons]:
            if type(b[1]) == str: b.insert(1, None) #hotkeys not defined
            
            name, hotkeys = b[:2]
            m = b[2:] #message
                 
            if type(m) == str: m = [m]
            if len(m) == 1: m = m + [prev_size]
            if len(m) == 2: m = m + [None]

            (text, size, alpha) = m
            b = vc_button_text(name, hotkeys, self, text, size, alpha,
                               RM = self.RM)
            self.items.append(b)

            prev_size = size


    def set_items_areas_SPECIAL(self):
        if self.scale_text_sizes:
            try:
                force_size = self.daddy.get_font_size(len(self.buttons))
            except:
                i = arr_id(self.real_arr)
                force_size = self.area.size[i] / (len(self.buttons) + 1) * (2 - i) / self.imgf.scale[1]
            no = vc_button_text._DONT_CHANGE
            for it in self.items:
                it.change_text(no, force_size)
        self.real_set_items_areas(self)


    def dynamic_reload(self, buttons):
        del self.items[:]
        self.buttons = buttons
        self.add_items()
        self.set_items_areas()

        self.new_session()


