from vcg_board import vcg_board
from vis_comp_group import vis_comp_group
from vcg_msgboard import vcg_msgboard
from pygame import Rect

class vcg_entitled_board(vis_comp_group):
    def __init__(self, title_data, daddy, stor, handler, prc_area,
                 board_img_id = 0,
                 title_alpha = "DONT CHANGE",
                 alpha = "DONT CHANGE"):
        self.s_title, self.prc_w_title, self.prc_h_title, self.sz_title = title_data
        self.title_alpha = title_alpha
        self.alpha = alpha
        self.my_items = []
        self.original_img_id = board_img_id
        
        vis_comp_group.__init__(self, daddy, stor, handler, prc_area)

    def add_items(self):
        def add(name, obj):
            setattr(self, name, obj)
            self.items.append(obj)
            self.my_items.append(obj)

        title_rect = Rect(0, 0, self.prc_w_title, self.prc_h_title)
        title_rect.centerx = 50
        add("title", vcg_msgboard(((self.s_title, self.sz_title),),
                                  self, self.stor, self.handler,
                                  title_rect, board_img_id = 1,
                                  scale_text_sizes = False,
                                  alpha = self.title_alpha))
        
        add("board", vcg_board(self, self.stor, self.handler,
                               (0, self.prc_h_title, 100, 100 - self.prc_h_title),
                               self.original_img_id,
                               self.alpha))

        self.board_items = self.board.board_items
        self.back_pic = self.board.back_pic

    def get_font_size(self, n):
        return self.board.get_font_size(n)



##    def render(self):
##        print "i am", self
##        print "rendering my items:", self.items
##        vis_comp_group.render(self)
##        
