from vis_comp_group import vis_comp_group
from vc_label import vc_label
from vcg_board import vcg_board
import constants as c_

class vcg_msgboard(vcg_board):
    
    def __init__(self, messages, daddy, stor, handler, prc_area, board_img_id = 0,
                 scale_text_sizes = True, alpha = "DONT CHANGE"):
        """__init__(self, messages, daddy, stor, handler, prc_area, scale_text_sizes = True)

        messages is a tuple of triples (text, size, alpha)
                            or duples (text, size)
                            or monoples (text,), except first element ->
                                size will be assumed same as previous item's
                            or string s, which is converted to (s,)
        """
        self.scale_text_sizes = scale_text_sizes
        self.messages = messages
        vcg_board.__init__(self, daddy, stor, handler, prc_area, board_img_id, alpha)


    def add_items(self):
        vcg_board.add_items(self)
        
        self.msglist = vcg_msglist(self.messages, self, self.stor, self.handler,
                                   (0, 0, 100, 100), self.scale_text_sizes)
        self.board_items.append(self.msglist)

        self.board_items = self.msglist.items


class vcg_msglist(vis_comp_group):
    
    def __init__(self, messages, daddy, stor, handler,
                 prc_area = (0, 0, 100, 100),
                 scale_text_sizes = True,
                 arrangement = "VERTICAL",
                 arrng_proport = None
                 ):
        self.scale_text_sizes = scale_text_sizes        
        self.messages = messages
        vis_comp_group.__init__(self, daddy, stor, handler, prc_area, "SPECIAL",
                                arrng_proport = arrng_proport)
        self.real_set_items_areas = getattr(vis_comp_group, "set_items_areas_%s" % arrangement) 


    def add_items(self):
        prev_size = 1

        for m in self.messages:
            if type(m) == str: m = (m,) #nothing but string
            if len(m) == 1: m = m + (prev_size,) #size missing
            if len(m) == 2: m = m + (None,) #alpha missing

            (text, size, alpha) = m
            b = vc_label(self, text, size, alpha)
            self.items.append(b)

            prev_size = size
                    
    def set_items_areas_SPECIAL(self):
        if self.scale_text_sizes:
            force_size = self.daddy.get_font_size(len(self.messages))
            no = vc_label._DONT_CHANGE
            for it in self.items:
                it.change_text(no, force_size)
        self.real_set_items_areas(self)
        
