from vis_comp_group import vis_comp_group, arr_id
from vcg_btnlist import vcg_btnlist
from vcg_empty import vcg_empty
from vis_comp import vis_comp
from img_holder import img_holder
import constants as c_
import time
import threading
from math import *


class vcg_option_list(vis_comp_group):
    def __init__(self, name, buttons_data, daddy, stor, handler,
                 prc_area = (0, 0, 100, 100),
                 scale_text_sizes = True,
                 arrangement = "VERTICAL",
                 arrng_proport = None,
                 init_choice_id = None,
                 reset_once = False,
                 report_only_new_values = True #don't report "VALUE CHANGED"
                                               #if clicking on selected item
                 ): 
        """__init__(self, buttons, daddy, stor, handler,
                 prc_area = (0, 0, 100, 100), arrangement = "CHILDREN"):

        buttons = ((name1, hotkeys1, text1, size1, alpha1),..)
        hotkeys, size and alpha may be missing
        size missing means take previous'
        alpha or hotkeys missing means None

        NOTE: 'self' is passed as handler to vcg_btnlist, not 'self.handler',
            so all key/mouse activity on those buttons is lost for outside,
            and the result is handled inside the class -> changes the option
        """

        self.name = name
        self.buttons_data = buttons_data
        self.scale_text_sizes = scale_text_sizes
        self.buttons_arrng = arrangement
        self.sel_shift = None
        self.init_choice_id = init_choice_id
        self.sessions = 0
        self.reset_once = reset_once
        self.report_only_new_values = report_only_new_values

        self.exit_query_lock = threading.Lock()  # used to exit from threa
        self.exit_report_lock = threading.Lock() #

        vis_comp_group.__init__(self, daddy, stor, handler,
                                prc_area = prc_area,
                                arrangement = "-" + arrangement,
                                arrng_proport = arrng_proport)

    def initial_click(self):
        if self.init_choice_id == None:
            b = None
        else:
            b = self.buttons[self.init_choice_id]
        self.selected = "NOTSET" #so we don't think value hasn't changed,
                                 #if previous .selected value was equal to b
        self.handle_IDENTIFIED_click(b)
        

    def handle_IDENTIFIED_click(self, button):
        if type(button) == str:
            button = [b for b in self.buttons if b.name == button][0]
            
        if hasattr(self, "selected") and (button is self.selected):
            if self.report_only_new_values:
                return
        self.selected = button

        if button == None:
            self.sel.visible = False
        else:
            self.sel.visible = True
            center = list(self.sel.center)
            center[self.ar_id] = button.center[self.ar_id]
            self.sel.center = tuple(center)

        try:
            getattr(self.handler, "handle_%s_value_changed" % self.name)(self.selected)
        except:
            pass #ok; handler not interested



    def add_items(self):
        sel_area = vcg_empty(self, self.stor, self.handler, None)
        self.items.append(sel_area)

        v_prc_area = [0, 0, 100, 100]
        self.ar_id = arr_id(self.buttons_arrng)
        v_prc_area[self.ar_id + 2] /= (len(self.buttons_data) + 1)
        v_prc_area = tuple(v_prc_area)
        


        ih = self.stor.imgf.duplicate_image(c_._IG_OPTIONLIST_SELECTION,
                                           1 - self.ar_id)
        sel = vis_comp(sel_area, ih, prc_area = v_prc_area, stretched = True)
        sel.get_shift = self.get_sel_shift
        self.sel = sel
        sel_area.items.append(sel)


        btns = vcg_btnlist(self.buttons_data, self, self.stor, self,
                           prc_area = None,
                           scale_text_sizes = self.scale_text_sizes,
                           arrangement = self.buttons_arrng,
                           RM = vis_comp._RM_ALWAYS)
        self.bntlist = btns
        self.buttons = btns.items
        self.items.append(btns)

    def new_session(self, force_reset = False):
        self.sessions += 1
        
        if self.exit_report_lock.locked(): #need to exit previous cycle
            self.exit_query_lock.acquire()
            self.exit_report_lock.acquire()
            self.exit_report_lock.release()
            self.exit_query_lock.release()


        vis_comp_group.new_session(self)

        if (self.sessions == 1) or (not self.reset_once) or force_reset:
            self.initial_click()

        self.sel_shift = [0, 0]
        self.thr_daddy.start_thread(self.thr_springing_selection, ())
        
    def thr_springing_selection(self):
        self.exit_report_lock.acquire()
        
        n = 7
        delays = [x * sqrt(x) / 250.0 for x in range(n)]
        i, di = 0, 1
        while 1:
            if self.thr_daddy.threads_must_stop or self.exit_query_lock.locked():
                break

            
            self.sel_shift[1 - self.ar_id] =  (3 - i) * 50 / n
            
            if i + di not in range(n): di = -di
            i += di

            time.sleep(delays[i])

        self.thr_daddy.some_thread_stopped()

        self.exit_report_lock.release()
        
    def get_sel_shift(self):
        return tuple(self.sel_shift)
        

    def dynamic_reload(self, buttons_data):
        self.exit_query_lock.acquire()
        self.exit_report_lock.acquire()
        self.exit_report_lock.release()
        self.exit_query_lock.release()

        del self.items[:]
        self.buttons_data = buttons_data
        self.add_items()
        self.set_items_areas()

        self.new_session(force_reset = True)
            

        
