from vcg_option_list import vcg_option_list, arr_id
from vis_comp_group import vis_comp_group
from vcg_scroll import vcg_scroll
from pygame.constants import K_UP, K_DOWN


class vcg_scrolled_option_list(vis_comp_group):
    def __init__(self, name, n_visible, buttons_data, daddy, stor, handler,
                 prc_area = (0, 0, 100, 100),
                 scale_text_sizes = True,
                 arrangement = "VERTICAL",
                 arrng_proport = [90, 10],
                 optlist_arrng_proport = [15, 85],
                 hotkeys_updown = (K_UP, K_DOWN),
                 init_top_visible = 0,
                 init_choice_id = None,
                 reset_once = False,
                 force_selection_visible = True,
                 scroll_prc = 30):
        "scroll_prc: which part is given to scrollbar's area"
        self.name = name
        self.n_visible = n_visible
        self.buttons_data = buttons_data
        self.arr = arrangement
        self.ar_id = arr_id(arrangement)
        self.arrng_proport = arrng_proport
        self.optlist_arrng_proport = optlist_arrng_proport
        self.hotkeys_updown = hotkeys_updown
        self.scale_text_sizes = scale_text_sizes
        self.init_top_visible = init_top_visible
        self.init_choice_id = init_choice_id
        self.sessions = 0
        self.reset_once = reset_once
        self.selected_id = None
        self.force_selection_visible = force_selection_visible
        self.scroll_prc = scroll_prc
        self.selected = None
        


        vis_comp_group.__init__(self, daddy, stor, handler, prc_area,
                                arrangement = "-" + arrangement,
                                arrng_proport = self.arrng_proport)

    def get_n_pages(self):
        return max(1, len(self.buttons_data) - self.n_visible + 1)

    def add_items(self):
        def add(obj):
            self.items.append(obj)

##        prc_area = (0, 0, 100, 100)
##        prc_area[2 + self.arr_id] = 100 - slf.scroll_prc
        self.optlist = vcg_option_list("OPTLIST", (), self, self.stor, self,
##                                       prc_area = tuple(prc_area),
                                       prc_area = None,
                                       scale_text_sizes = self.scale_text_sizes,
                                       arrangement = self.arr,
                                       arrng_proport = self.optlist_arrng_proport,
                                       reset_once = self.reset_once)
        add(self.optlist)

##        prc_area = (0, 0, 100, 100)
##        prc_area[self.arr_id] = 100 - slf.scroll_prc
##        prc_area[2 + self.arr_id] = slf.scroll_prc
        self.scroll = vcg_scroll("SCROLL", 0, self.get_n_pages() - 1,
                                 self, self.stor, self,
##                                 prc_area = tuple(prc_area),
                                 prc_area = None,
                                 vinit = "min",
                                 hotkeys_updown = self.hotkeys_updown,
                                 arrangement = self.arr)
        add(self.scroll)
        
    def new_session(self, force_reset = False):
        self.sessions += 1
        if (self.sessions == 1) or (not self.reset_once) or force_reset:
            self.top_visible = self.init_top_visible

            if len(self.buttons_data) > self.init_choice_id:
                self.selected_id = self.init_choice_id
            else:
                self.selected_id = None
            self.react_on_next_OPTLIST_change = False
            self.load_items_to_optlist()
     
            self.react_on_next_OPTLIST_change = True
            
        vis_comp_group.new_session(self)

    def set_optlist_init_choice(self):
        if self.selected_id == None:
            r = None
        else:
            v = self.selected_id - self.top_visible
            if self.force_selection_visible:
                if v < 0:
                    v = 0
                    self.react_on_next_OPTLIST_change = True
                if v > self.n_visible - 1:
                    v = self.n_visible - 1
                    self.react_on_next_OPTLIST_change = True
                r = v
            else:
                if v in range(self.n_visible):
                    r = v
                else:
                    r = None
        self.optlist.init_choice_id = r

    def load_items_to_optlist(self):
        start = self.top_visible
        stop = start + self.n_visible
        self.set_optlist_init_choice()
        with_extra = self.buttons_data + (("",""),) * self.n_visible
        self.optlist.dynamic_reload(with_extra[start : stop])
        

    def handle_OPTLIST_value_changed(self, selected):
        if not self.react_on_next_OPTLIST_change:
            self.react_on_next_OPTLIST_change = True
            return
        self.selected = selected
        if selected != None:
            self.selected_id = self.optlist.buttons.index(selected) + self.top_visible
        else:
            self.selected_id = None

##        print "otplist selection:", selected.name
##        print "selid", selid

        try:
            getattr(self.handler, "handle_%s_value_changed" % self.name)(self.selected)
        except:
            pass #ok; handler not interested


    
    
    def handle_SCROLL_value_changed(self, value):
        self.top_visible = value
        self.react_on_next_OPTLIST_change = False
        self.load_items_to_optlist()        

    def dynamic_reload(self, buttons_data, init_choice_id = "NOTSET"):
        del self.items[:]
        self.buttons_data = buttons_data
        if init_choice_id != "NOTSET":
            self.init_choice_id = init_choice_id
        self.add_items()
        self.set_items_areas()

        self.new_session(force_reset = True)        


    
