"visual components"

from common_ import blit_, blit_unerase
from mouse_sensitive_rect import mouse_sensitive_rect
from pygame import Rect
import img_list as M_img_list
from img_holder import img_holder
import snd_list as M_snd_list
from snd_holder import snd_holder
import my_maths

class vis_comp(mouse_sensitive_rect):
    #refresh modes   
    (_RM_BACKGROUND, #blit on background an forget
     _RM_ON_CHANGE,  #remember last state and re-render only when it's changed
     _RM_ALWAYS,     #every frame
    ) = range(3)
    def __init__(self, group, img_list, snd_list = None,
                 RM = _RM_ALWAYS,
                 prc_area = None,
                 stretched = False):
        mouse_sensitive_rect.__init__(self)

        if img_list.__class__ == img_holder:
            img_list = M_img_list.img_list(group.imgf,
                                           (img_list.img_gr, img_list.img_id, 1))
        if snd_list.__class__ == snd_holder:
            snd_list = M_snd_list.snd_list(group.sndf,
                                           (snd_list.snd_gr, snd_list.snd_id, 1))

        self.group = group
        self.prc_area = prc_area
        self.imgf = group.imgf
        self.sndf = group.sndf
        self.stor = group.stor
        self.img_list = img_list
        self.snd_list = snd_list
        self.now_sound = None
        self.center = self.area = None
        self.alpha = None
        self.angle = 0
        self.refresh_mode = RM
        self.stretched = stretched

    def is_group(self):
        return False

    def get_daddy_area(self):
        return Rect(self.group.area)

    def calc_area(self):
        return my_maths.calc_prc_area(self.get_daddy_area(), self.prc_area)

    def reset_area(self, prc_area = None):
        if prc_area != None: self.prc_area = prc_area
        area = self.calc_area()
        self.center = area.center
        if self.stretched:
            self.stretch_to(area.size)

    def stretch_to(self, size):
##        print "my prc:", self.prc_area
##        print "daddy's area:", self.group.area
##        print "size:", size
        for ih in self.img_list:
           self.imgf.groups[ih.img_gr][ih.img_id].resize_to(size)
            
    def render(self):
        if not self.get_visible():
            return False
        
        if self.refresh_mode == self._RM_ON_CHANGE:
            if self.get_changed():
                self.render_image(visible = False)
                self.render_image()
                self.img_list.prev_rect = self.area #remember to erase next time
                #mark as rendered
                self.img_list.active_changed = False

        else:
            self.render_image()
            
        return True    
            
    def get_changed(self):
        return self.img_list.active_changed
        

    def render_image(self, id = None, visible = True):
        #get image    
        if id is None: id = self.img_list.active_id
        if self.alpha is None:
            img = self.imgf.get_image(self.img_list[id], self.angle)
        else:
            img = self.imgf.get_image_alpha(self.img_list[id], self.angle,
                                      self.alpha)
        #coordinates
        r = img.img[1]
        shift = map(lambda x, y: x * y / 100, self.get_shift(), r.size)
        r.center = map(lambda x, y: x + y, self.center, shift)

        #erasing previous?
        if not visible:
            if self.img_list.prev_rect:
                r = self.img_list.prev_rect
        
        #blit
        if self.refresh_mode != self._RM_BACKGROUND:
            blit = (self.refresh_mode == self._RM_ON_CHANGE) and blit_unerase or blit_
            blit(self.stor, img.img[0], r, visible)
        else:
            self.stor.background.blit(img.img[0], r)

        #save last rect as personal area
        self.area = Rect(r)

    def get_shift(self):
        "in percents of self size"
        return (0, 0)

    def do_sound(self, id = None):
        """this mess with do_sound and do_sound_ is needed for Settings dialog,
        which is the only place where we need the clicksound BEFORE mouseup"""
        self.do_sound_(id) 

    def do_sound_(self, id = None):
        if id is None: id = self.snd_list.active_id
        self.now_sound = self.sndf.get_sound(self.snd_list[id])
        

    def do_sound_not1(self, id = None):
        "stupid, but needed urgently"
        if id is None: id = self.snd_list.active_id
        if id != 1:
            self.do_sound_(id)
    
    def new_session(self):
        mouse_sensitive_rect.new_session(self)
        self.img_list.new_session()
