from mouse_sensitive_rect import mouse_sensitive_rect
from vis_comp import vis_comp
from pygame import Rect
import my_maths

class items_vcg(list):
    def __init__(self, daddy):
        list.__init__(self)
        self.daddy = daddy

    def append(self, obj):
        list.append(self, obj)
        if obj.is_group():
            self.daddy.child_group_items.append(obj)
        elif obj.refresh_mode == vis_comp._RM_BACKGROUND:
            self.daddy.background_items.append(obj)
        else:
            self.daddy.rerendered_items.append(obj)

    def extend(self, new_list):
        for item in new_list:
            self.append(item)
    
    def __delitem__(self, id):
        obj = self[id]
        list.__delitem__(self, id)
        count = 0
        for lst in (self.daddy.child_group_items,
                    self.daddy.background_items,
                    self.daddy.rerendered_items):
            try:
                del lst[lst.index(obj)]
                count += 1
            except:
                pass #ok; wrong in list
        assert(count == 1)

    def __delslice__(self, i, j):
        while j < 0: j+= len(self)
        if j > len(self): j = len(self)
        for k in range(i, j):
            self.__delitem__(i)

                

def arr_id(arr):
    return ["HORIZONTAL", "VERTICAL"].index(arr)

class vis_comp_group(mouse_sensitive_rect):
    def __init__(self, daddy, stor, handler,
                 prc_area = (0, 0, 100, 100), arrangement = "CHILDREN",
                 arrng_proport = None,
                 auto_place_items = False):
        """prc_area means coordinates are given in percents of stor.screen size:
        (kleft, ktop, kwidth, kheight)
        
        possible default arrangements are
            VERTICAL,
            HORIZONTAL,
            CHILDREN
        """
        mouse_sensitive_rect.__init__(self)

        self.daddy = daddy
        self.thr_daddy = self.determine_threading_daddy(daddy)
        self.stor = stor
        self.handler = handler
        self.imgf = stor.imgf
        self.sndf = stor.sndf
        self.prc_area = prc_area

        #arrangement : -VERTICAL = HORIZONTAL; -HORIZ = VERT; --ANY = ANY
        arrangement = arrangement.replace("--", "")
        arrangement = arrangement.replace("-VERTICAL", "HORIZONTAL")
        arrangement = arrangement.replace("-HORIZONTAL", "VERTICAL")
        self.set_items_areas = getattr(self, "set_items_areas_%s" % arrangement)
        self.arrangement = arrangement
        self.arrng_proport = arrng_proport
        
        self.items = items_vcg(self)
        self.child_group_items = []
        self.background_items = []
        self.rerendered_items = []
        
        self.add_items()
        if auto_place_items:
            self.reset_area()

    def is_group(self):
        return True

    def get_child_handler(self):
        return self.handler
    
    def add_items(self):
        raise NotImplementedError

    def get_daddy_area(self):
        daddy = self.daddy
        if hasattr(daddy, "area"):
            return Rect(daddy.area)
        else:
            return self.stor.screen.get_rect()

    def calc_area(self):
        return my_maths.calc_prc_area(self.get_daddy_area(), self.prc_area)

    def reset_area(self, prc_area = None):
        if prc_area != None: self.prc_area = prc_area
        self.area = self.calc_area()
        self.set_items_areas()

    def render_background(self):
        for it in self.background_items:
            it.render()
        for it in self.child_group_items:
            it.render_background()
        
    def render(self):
        needed = self.rerendered_items + self.child_group_items
        for it in self.items:
            if it in needed:
                it.render()

    def set_items_areas_VERTICAL(self):
        self.set_items_areas_HORIZVERT(0)

    def set_items_areas_HORIZONTAL(self):
        self.set_items_areas_HORIZVERT(1)

    def set_items_areas_HORIZVERT(self, mode):
        n = len(self.items)
        if n == 0:
            return

        prop = self.arrng_proport
        if prop == None:
            prop = (100.0 / n,) * n
        dh = 100.0 / (n + 0)
        last_h = dh / 2.0 * 0
        for i in range(n):
            my_dh = dh * prop[i] * n / 100.0
            h = last_h

            rect = [0, 0, 100, 100]
            rect[1 - mode] = int(h)
            rect[3 - mode] = int(my_dh)
            self.items[i].reset_area(Rect(rect))

            last_h = h + my_dh

    def set_items_areas_CHILDREN(self):
        for it in self.items:
            it.reset_area()
        

    def mouse_is_moving(self, pos):
        for it in self.items:
            if it.get_visible():
                it.mouse_is_moving(pos)

    def mouse_is_pressed(self, buttons, pos):
        for it in self.items:
            if it.get_visible():
                it.mouse_is_pressed(buttons, pos)
            
    def on_key_down(self, key):
        for it in self.items:
            if it.get_visible():
                it.on_key_down(key)
            
    def on_key_up(self, key):
        for it in self.items:
            if it.get_visible():
                it.on_key_up(key)
            

    def new_session(self):
        mouse_sensitive_rect.new_session(self)
        for it in self.items:
            it.new_session()
        self.render_background()

    def determine_threading_daddy(self, daddy):
        "find a grandparent responsible for threading"
        while not hasattr(daddy, "start_thread"):
            daddy = daddy.daddy
        return daddy


