import sys, socket

CMD_LEN_BIT_SIZE = 1

def cmd_to_str(cmd_id, cmd_text):
    s_sz = ""
    cmd_sz = len(cmd_text)
    for i in range(CMD_LEN_BIT_SIZE):
        s_sz += chr(cmd_sz % 256)
        cmd_sz >>= 8
    return chr(cmd_id) + s_sz + cmd_text
 
def str_to_cmd(s):
    """only header is parsed (no text)
    returns a duple: (id, len)
    """
    id = ord(s[0])
    sz = 0
    for i in range(CMD_LEN_BIT_SIZE):
        sz <<= 8
        sz += ord(s[CMD_LEN_BIT_SIZE - i])
    return (id, sz)
    
    
def read_fixed(con, buff):
    data = []
    got = 0
    while got < buff:
        closed = False
        try:
            chunk = con.recv(min(buff - got, 1024))
            if not chunk: closed = True
            data.append(chunk)
            got += len(chunk)
        except socket.error, msg:
            if msg.args[0] == 10054:
                closed = True #"connection reset by peer"
##            else:
##                print msg.args[0]

        if closed: break

    if closed:
        print "disconnected on receiving"
        return None
    else:
        s = "".join(data)
        return s

def send_text(con, text):
    try:
        sent = 0
        need = len(text)
        while sent < need:
            chunk = con.send(text[sent:])
            if chunk == 0:
                print "0 bytes sent"
            if chunk is None:
                print "chunk is None"
            sent += chunk
        return sent
    except:
        return None

    
    

if __name__ == "__main__":
    print cmd_to_str(65, "12345678901234567890123456789012")
    print str_to_cmd(cmd_to_str(65, "12345678901234567890123456789012"))

    
