class net_values:
    def __init__(self):
        self.user_data = ((0, 0), 0, 0, 0) #(x, y), stick, fire, req
        self.cloud_dxy = [0, 0] * clouds_n
        self.events = [] #each event is a tuple (id, param1, param2), all 1 byte



ui_bit_size_mask = (2, 2, 1, 1, 1)     # x, y, stick, fire, req
ui_n = len(ui_bit_size_mask)
clouds_n = None
G_bit_size_mask = None

def set_current_bsm():
    global G_bit_size_mask
    G_bit_size_mask = ui_bit_size_mask + clouds_n * (2, 2)

p256d2 = [(1 << (x * 8)) / 2 for x in range(4)]

def encode(values):
    ud = values.user_data
    clouds = tuple(map(lambda x: int(x * 10000.0), values.cloud_dxy))
    events = tuple(values.events)
    events_n = len(events) / 3
    
    seq = (ud[0][0], ud[0][1], ud[1], ud[2], ud[3]) + clouds + (events_n,) + events
    n = ui_n + 2 * clouds_n + 1 + 3 * events_n
    bit_size_mask = G_bit_size_mask + (1,) + (1, 1, 1) * events_n
##    print "outseq = %s" % str(seq)
    
    for i in range(n): assert(abs(seq[i]) < p256d2[bit_size_mask[i]]) # for negatives
    to_s = []
    it_i = 0
    for it in seq:
        sz = bit_size_mask[it_i]
        v = it + p256d2[sz] # for negatives; (-128..127)
        for i in range(sz):
            to_s.append(v & 255)
            v >>= 8
        it_i += 1
##    print to_s
    return "".join([chr(x) for x in to_s])

def decode(str_values, values):
    def read_chunk(bit_size_mask, pos, n):
        for it in range(n):
            sz = bit_size_mask[it]
            v = 0
            for j in range(sz):
                v = (v << 8) + from_s[pos + sz - j - 1]
            pos += sz
            seq.append(v - p256d2[sz])
        return pos

    from_s = [ord(c) for c in str_values]
    seq = []
    pos = 0

    n = ui_n + 2 * clouds_n + 1
    bit_size_mask = G_bit_size_mask + (1,)
    pos = read_chunk(bit_size_mask, pos, n)

    events_n = seq[-1]
    events_pos = n
    n = 3 * events_n
    bit_size_mask = (1, 1, 1) * events_n
    pos = read_chunk(bit_size_mask, pos, n)
    
                
##    print "froms = %s" % from_s
##    print "inseq = %s" % str(seq)
    values.user_data = ((seq[0], seq[1]), seq[2], seq[3], seq[4])
    values.cloud_dxy = tuple(map(lambda x: x / 10000.0, seq[5: 5 + clouds_n * 2]))
    values.events = seq[events_pos: events_pos + 3 * events_n] 
    

if __name__ == "__main__":
    clouds_n = 3
    set_current_bsm()
    print G_bit_size_mask
    
    st = net_values()
    st.user_data = ((-32000, 15), 2, 12, -122)
    st.cloud_dxy[3] = -0.002
    st.events = [1, 2, 3, 4, 5, 6, -3, -3, -1]
    decode(encode(st), st)
    print st.user_data
    print st.cloud_dxy
    print st.events


 

##if __name__ == "__main__":
##    st = net_values()
##    st.x = 1200
##    st.y = -32700
##    decode(encode(st), st)
##    print st.x, st.y
##


##def encode(data):
##    (x, y), stick, fire, req = data
##    #x, y - 2 bytes
##    #stick - 2 bits
##    #fire - 1 bit
##    #req - 1 byte
##
##    x += 16000;  y += 16000
##    assert((0 < x) and (x < 32000) and (0 < y) and (y < 32000))
##    send = [x >> 8, x & 255, y >> 8, y & 255, (fire << 2) + stick, req]
##    return "".join([chr(i) for i in send])
##
##def decode(s):
##    v = [ord(c) for c in s]
##    x = (v[0] << 8) + v[1] - 16000
##    y = (v[2] << 8) + v[3] - 16000
##    fire, stick = v[4] >> 2, v[4] & 3
##    req = v[5]
##    return [[x, y], stick, fire, req]
