import Queue as Q
from encoding import *
import encoding as M_encoding
import constants as c_
import sys
from common_ import print_
import threading

DEF_LATENCY = 0 #number of packages in queue
QUEUE_TIMEOUT = 0.03

def dprint(string):
    if 0:
        print_( string )

class net_storage:
    def __init__(self, gm, sock):
        self.gm = gm
        self.stor = gm.stor
        self.sock = sock
        self.disconnected = False

        #init net_values with current map's parameters
        M_encoding.clouds_n = self.stor.settings.map().data["clouds_n"]
        M_encoding.set_current_bsm()

        self.my_in_vals = net_values()
        self.his_in_vals = net_values()
        self.my_out_vals = net_values()

        self.my_out_lock = threading.Lock()

        self.my_in_q = Q.Queue()
        self.his_in_q = Q.Queue()
        self.my_out_q = Q.Queue()


        self.fake_feed(DEF_LATENCY)


    def fake_feed(self, n_packs):
        for i in range(n_packs):
            self.my_in_q.put(encode(net_values()))
            self.his_in_q.put(encode(net_values()))



    def exchange(self):
        dprint( "exchange")

        self.my_out_lock.acquire()
        my = encode(self.my_out_vals)
        self.my_out_vals.events = []
        self.my_out_lock.release()
        
        self.my_out_q.put(my)
        dprint( "1" )
        self.my_in_q.put(my)
        dprint( "2" )
        while 1:
            if self.disconnected: return
            try:
                decode(self.my_in_q.get(True, QUEUE_TIMEOUT), self.my_in_vals)
                break
            except:
                pass
            
        dprint( "3" )
        while 1:
            if self.disconnected: return
            try:
                decode(self.his_in_q.get(True, QUEUE_TIMEOUT), self.his_in_vals)
                break
            except:
                pass
        
        dprint(" 4 ")
        #in this very order: maybe his data was just about to come,
        # so we send ours not to loose time;
        # we should wait only when there's nothing to do left


    def need_exit_threads(self):
        return self.gm.threads_must_stop #may ask gm here
    
    def thr_io(self):

        def send_when_have():
            dprint( "sending" )
            while not self.need_exit_threads():
##                cmd = self.my_out_q.get(QUEUE_TIMEOUT)
                try:
                    cmd = self.my_out_q.get(True, QUEUE_TIMEOUT)
                    dprint( "ready to send:" )
                    dprint( cmd )
                    if self.sock.send_command(c_._CMD_STATUS_UPDATE, cmd) is None:
                        print_( "disconnected on send" )
                        self.disconnected = True
                        return False
                    dprint( "returning True" )
                    return True
                except Q.Empty:
                    pass
                except:
                    print_( "Unexpected error:", sys.exc_info()[0] )
            return False

        def recv_when_have():
            dprint( "receiving" )
            id, cmd = self.sock.read_command()
            dprint( "yes: %s" % cmd )
            if not(id == c_._CMD_STATUS_UPDATE):
                print_( "disconnected on recv" )
                self.disconnected = True
                return False
            self.his_in_q.put(cmd)
            return True

        dprint( "deciding which cycle" )
        if self.gm.send_first():
            while 1:
                if not send_when_have(): break
                if not recv_when_have(): break
        else:
            while 1:
                if not recv_when_have(): break
                if not send_when_have(): break
                    
        #leaving thread
        print_( "leaving io thread" )
        dprint( self.disconnected )
        self.gm.some_thread_stopped()
                
