import socket
from com_network import *
import constants as c_


class sock:
    def __init__(self, host):
        self.host = host
        self.port = c_._PORT

        self.sockobj = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.sockobj.settimeout(0.001)

        self.curcon = None
        self.connected = False

    def read_command(self):
        """format:
        command_id - 1 byte
        command_size - 4 bytes
        command_text - command_size bytes

        returns a tuple (int id, int size, str text)"""
        if not self.connected:
            return (None, None)
        
        cmd = read_fixed(self.curcon, 1)
        if cmd is None: return (None, None)
        if len(cmd) < 1:
            return (None, None)
        
        sz = read_fixed(self.curcon, CMD_LEN_BIT_SIZE)
        if sz is None: return (None, None)
        cmd, sz = str_to_cmd(cmd + sz)
        
        text = read_fixed(self.curcon, sz);
        if text is None: return (None, None)

#        print len(text) + 2
        return (cmd, text)

    def send_command(self, cmd, obj):
        return send_text(self.curcon, cmd_to_str(cmd, str(obj)))           

     
    def close(self):
        if self.connected:
            self.connected = False
            self.curcon.close
            self.curcon = None
        self.sockobj.close()
