from socket import *
from constants import _PORT
import time

_REPEAT = 5
_TIMEOUT = 2

class udp_client:
    def __init__(self):
        self.sock = socket(AF_INET, SOCK_DGRAM) 
        self.sock.setsockopt(SOL_SOCKET, SO_BROADCAST, 1)
        self.sock.settimeout(_TIMEOUT)
        self.dest = ('<broadcast>', _PORT)

    def find_servers(self):
        servers = []
        
        s = self.sock
        try:
            for _ in range(_REPEAT):
                s.sendto("?", self.dest)
        except:
            return servers
            
        t0 = time.time()
        while 1:
            dt = time.time() - t0
            if dt > _TIMEOUT:
                break
            s.settimeout(_TIMEOUT - dt)

            try: 
                data, addr = s.recvfrom(1024)
            except:
                break

            if not [x for x in servers if x[1] == addr[0]]:
                servers.append((data, addr[0]))

        return servers

    def close(self):
        self.sock.close()
