from socket import *
from constants import _PORT

_REPEAT = 5

class udp_server:
    def __init__(self, message, autorun = True):
        self.message = message
        self.sock = socket(AF_INET, SOCK_DGRAM) 
        self.sock.setsockopt(SOL_SOCKET, SO_BROADCAST, 1)
        self.sock.settimeout(0.001)
        
        self.is_bind = False
        if autorun:
            self.is_bind = self.prepare()

    def prepare(self):
        try:
            self.sock.bind( ("", _PORT) )
            return True
        except:
            return False

    def listen_and_response(self):
        try:
            (data, addr) = self.sock.recvfrom(64)
        except:
            return False

        for _ in range(_REPEAT):
            self.sock.sendto(self.message, addr)
        

    def close(self):
        self.sock.close()
