from icon import icon
from icon_group import icon_group
from icon_health import icon_health
from icon_flower import icon_flower
from anim_flower import anim_flower
from img_holder import img_holder
import toolbar
import constants as c_
from snd_holder import snd_holder

class player_info:
    def_start_health = 100
    critical_health = 15
    
    def __init__(self, stor, player, start_health = def_start_health):
        self.stor = stor
        self.player = player
        self.player_id = player.player_id
        self.color = getattr(self, 'get_color_%d' % self.player_id)()
        
        self.health = start_health
        self.strength = 3
        self.win_message = "%s wins!" % player.name

        self.sh_woohoo = snd_holder(c_._SG_BOUNTY, 5)
        self.sh_ohoh = snd_holder(c_._SG_BOUNTY, 7)
        
        

        xy = getattr(self, 'get_coords_%d' % self.player_id)()
        w = toolbar.get_height(self.stor.imgf.scale)
        print "creating icon group"
        self.icon_gr = icon_group(self.stor,
                                  xy[0], xy[1],
                                  w, w,
                                  left_to_right = (3 - self.player_id * 2))
        self.player.set_toolbar_icon_gr(self.icon_gr)

        add = self.icon_gr.add_icon
        self.flower_icon = add(icon_flower(self.stor, self),
                               shift = (0.3 * self.player.x_axis_dir, 0),
                               post_shift_k = 0.3)
        self.health_icon = add(icon_health(self.stor, self),
                               shift = (0.8 * self.player.x_axis_dir, 0.4),
                               post_shift_k = 5.0)

        if self.player.need_server_icon():
            icon_id = self.stor.settings.server_icon
            ih = img_holder(c_._IG_SERVER_ICONS, icon_id)
            self.server_icon = add(icon(self.stor, ih = ih))

        #animations
        self.anim_flower = anim_flower(self.stor, self.flower_icon, self, 
                                       player.get_health_flower_img_gr())
##for debug:
##        add(icon_health(self.stor, self))
##        add(icon_health(self.stor, self))
##        add(icon_health(self.stor, self))
##        add(icon_health(self.stor, self))

    def render(self, visible):
        self.icon_gr.render(visible)
        

    def get_coords_1(self):
        return [0, 0]

    def get_coords_2(self):
        return [self.stor.screen.get_rect().right, 0]

    def get_color_1(self):
        return (0, 0, 255)

    def get_color_2(self):
        return (0, 255, 0)

    def incr_health(self, incr):
        was = self.health
        self.health = min(self.health + incr, player_info.def_start_health)
        mx = self.def_start_health
        if ((was < mx) and (self.health == mx)):
            self.now_sound = self.stor.sndf.get_sound(self.sh_woohoo)
        if ((was > self.critical_health) and
            (self.health <= self.critical_health)):        
            self.now_sound = self.stor.sndf.get_sound(self.sh_ohoh)
        
