from ci_mouse import ci_mouse
from ci_keyboard import ci_keyboard
from ci_both import ci_both
import ci_mouse as M_ci_mouse
import ci_ai_spider as M_ci_ai_spider
from map import map
import meat as M_meat


(DEV_MOUSE
,DEV_KEYBOARD
,DEV_BOTH
) = range(3)

(CHR_SNAKE
,CHR_SPIDER
) = range(2)

ci = (ci_mouse, ci_keyboard, ci_both)

class settings:
    def __init__(self, stor):
        self.stor = stor

        self.device = [DEV_MOUSE, DEV_KEYBOARD]
        self.main_device = DEV_BOTH
        self.__chars = [CHR_SNAKE, CHR_SNAKE]
        
        self.map = map
        self.sound = True

        self.timescale = 1.0
        self.difficulty = 1

        self.server_icon = None
    def get_ci(self, player_id):
        return ci[self.device[player_id - 1]]

    def get_main_ci(self):
        return ci[self.main_device]

    def set_timescale(self, ts):
        self.timescale = ts
        M_ci_mouse.time_scale_changed(ts)
        M_ci_ai_spider.time_scale_changed(ts)
        M_meat.time_scale_changed(ts)

    def get_characters(self, gm):
        """
        currently characters are forced:
        in AI mode, snake VS spider,
        in other modes - snake VS snake.

        in future will return self.__chars
        """
        if gm.__class__.__name__ == "gm_ai":
            return (CHR_SNAKE, CHR_SPIDER)
        else:
            return (CHR_SNAKE, CHR_SNAKE)

    
    def glob_sfx_vol_changed(self, val):
        self.stor.sndf.set_glob_sfx_vol(float(val) / 10.0)

    def glob_mus_vol_changed(self, val):
        self.stor.sndf.set_glob_mus_vol(float(val) / 10.0)
        

