#connection between to balls

from math import *
from my_maths import *
import pygame
from img_holder import img_holder
import constants as c_
from common_ import blit_

def time_scale_changed(ts):
    meat._timescale = ts

class meat:
    _timescale = 1.0

    def __init__(self, a, b, dist_k = 1.2, elast = 0.25, img_gr = c_._IG_MEAT,
                 visible = True):
        "dist_k is (normal disance between centers)/(ra + rb)"
        self.a, self.b, self.elast = (a, b, elast)
        self.set_dist_k(dist_k)
        self.ih = img_holder(img_gr, 0)
        self.stor = a.stor
        self.visible = visible
        self.active = True
        self.norm_dist_koef = 1.0

        self.cached_rect = None
        self.imgf_get_image = self.stor.imgf.get_image
        #sets:
       #self.dist_k,
       #self.norm_dist

    def set_active(self, is_active, is_visible = None):
        self.active = is_active
        if is_visible == None: is_visible = is_active
        self.visible = is_visible

    def render(self, stor, visible):
        if not self.visible: return

        if not visible:
            if self.cached_rect:
                blit_(stor, None, self.cached_rect, visible)
                self.cached_rect = None
            return
            
        #determine img_id - depends on length
        a = self.a.crd
        b = self.b.crd
        w, h = a[0] - b[0], a[1] - b[1]
        dst = sqrt(w * w + h * h)
        if dst < self.a.r + self.b.r - 1e-2:
            return
        s_dst = int(dst / self.a.r * self.a.def_size[0])
##        print "s_dst = %d" % s_dst
        self.ih.img_id = s_dst

        #determine output position
        sa = stor.physics.world_to_scr(self.a.crd)
        sb = stor.physics.world_to_scr(self.b.crd)
        x, y = (sa[0] + sb[0]) / 2, (sa[1] + sb[1]) / 2

        #determine angle
        ang = angle_a_to_b(a, b)

        #output
        try:
            img = self.imgf_get_image(self.ih, angle = ang)
        except:
            return
        rect = pygame.Rect(img.img[1])
        rect.center = (x, y)
##        print "x, y = ", x, y
##        print "a = ", ang
##        print "img = ", img
        blit_(stor, img.img[0], rect, visible)
        self.cached_rect = rect


    def set_dist_k(self, dist_k):
        if dist_k != "AUTO":
            self.dist_k  = dist_k
            self.norm_dist = (self.a.r + self.b.r) * dist_k
        else:
            self.norm_dist = dist_a_to_b(self.a.crd, self.b.crd)
            self.dist_k = self.norm_dist / (self.a.r + self.b.r)

        
    def take_affect(self, scale = 1):
        if not self.active: return
        
        a = self.a
        b = self.b
        
        assert(not (a is b))
        vax, vay = a.crd[0], a.crd[1]
        vbx, vby = b.crd[0], b.crd[1]
        dist = sqrt((vax - vbx) * (vax - vbx) + (vay - vby) * (vay - vby))
        vabx, vaby = (vbx - vax) / dist, (vby - vay) / dist
        vbax, vbay = -vabx, -vaby

#        stretch = (dist - r_ab + 0.1) / (self.norm_dist - r_ab + 0.1)
#        stretch = (dist / self.norm_dist)
#        print stretch
#        if stretch > 2: stretch = 2
#        if stretch < 0.8: stretch = 0.8

 #       k = log(1.0 / stretch) * self.elast

        d = self.norm_dist * self.norm_dist_koef - dist
        k = d * self.elast * 0.00325 * scale / self._timescale * 0.25

#        print "mass = %s %s" % (a.mass, b.mass)
        ak, bk = k / a.mass , k / b.mass

        a.speed[0] += vbax * ak
        a.speed[1] += vbay * ak
        
        b.speed[0] += vabx * bk
        b.speed[1] += vaby * bk

        
        
