import constants as c_
from math import *
from my_maths import *
from ball import ball
from meat import meat
from common_ import print_
from img_holder import img_holder
from snd_holder import snd_holder
from char_body import char_body

class snake_body(char_body, ball):
    def __init__(self, snake, id, prev_ball, next_ball, obj_group, stor, x, y,
                 img_gr = c_._IG_BODY, img_id = 0,
                 friction = 0.1, solidity = 1.0, string = "anonymous ball",
                 detached_friction = 0.03, def_size = c_._WH_BODY):
        char_body.__init__(self, snake, friction, detached_friction, solidity)
        
        self.prev_ball = prev_ball
        self.next_ball = next_ball
        self.snake = snake
        self.id = id
        ball.__init__(self, obj_group, stor, x, y, img_gr, img_id, friction, solidity, string, def_size)
        self.friction = friction 

        self.releasable = False
        self.is_tail = False
        

    def make_detached(self):
        char_body.make_detached(self)
        if self.cursed: #when snake detaches cursed ball, curse releases
            self.uncurse()
        if self.__class__ is snake_body:
            self.ih_main.img_gr = c_._IG_SHOT

    def make_releasable(self, force_images_change):
        self.releasable = True
        if force_images_change:
            if self.__class__ is snake_body:
                self.ih_main.img_gr = c_._IG_RELEASABLE_BODY
        
    def make_non_releasable(self, force_images_change):
        self.releasable = False
        if force_images_change:
            if self.__class__ is snake_body:
                self.ih_main.img_gr = c_._IG_BODY
        
    def get_image_angle(self):
        if self.attached:
            return angle_a_to_b(self.crd, self.prev_ball.crd)
        else:
            return angle_a_to_b(self.crd, self.snake.last_attached.crd)

    def glues_b(self, b):
        return (   (self.attached) and
                   (self.obj_gr == b.obj_gr)and
                   (not b.attached) and
                   #tail shouldn't be inserted, only attached in the end
                   ((self.next_ball == None) or (not b.may_glue_to_last_only()))
               )
    
    def glue_b(self, b):
        char_body.glue_b(self, b)
        
        #add link'
##        print "link!"
##        print " ".join(["%s" % it.sticky for it in self.snake.balls])
##        print self.string
##        print b.string

        #update links connections
        snake = self.snake
        snake.meats.append(meat(self, b))
        if self.next_ball:
            snake.kill_meat(self, self.next_ball)
            snake.meats.append(meat(b, self.next_ball))
        #include new ball
        b.make_attached()
        #update pointers to next/prev ball
        b.prev_ball = self
        b.next_ball = self.next_ball
        if self.next_ball:
            self.next_ball.prev_ball = b
        else:#self is last attached element; reassign
            self.snake.last_attached = b
        self.next_ball = b
        self.snake.mark_bullets(False)
        
        print_( "attached to player %d" % self.player.player_id )


    def may_glue_to_last_only(self):
        return False

        
