from char_body import char_body
from ball import ball
import constants as c_
from my_maths import *

_IMG_ID0 = c_._in_IG_BODY_SPIDER_ID0

class spider_body(char_body, ball):
    uncurse_after = 2.0 #start uncursing after x seconds
    
    def __init__(self, spider, id, obj_group, stor, x, y,
                 img_gr = c_._IG_BODY, img_id = 0,
                 friction = 0.1, solidity = 1.0,
                 string = None,
                 detached_friction = 0.03,
                 def_size = c_._WH_BODY,
                 visible = True,
                 collidable = True,
                 vulnerability = 1.0
                 ):
        if type(id) == list:
            id[0] += 1
            id = id[0] - 1
        self.id = id


        if string == None:
            string = "anonymous spider ball %d" % self.id
        if img_gr == c_._IG_BODY:
            img_id += _IMG_ID0 
        char_body.__init__(self, spider, friction, detached_friction, solidity)
        ball.__init__(self, obj_group, stor, x, y, img_gr, img_id,
                      friction, solidity, string, def_size,
                      collidable, vulnerability)
        self.visible = visible

    def curse(self):
        char_body.curse(self)
        self.char.got_cursed()

    def get_image_angle(self):
        return 0

    def render(self, stor, visible):
        if self.visible:
            char_body.render(self, stor, visible)

    def recognizable_by_clouds(self):
        return self.collidable #so clouds don't ask for bones[*].id

    def get_image_angle(self):
        dir_point = self.char.head.crd
        return angle_a_to_b(self.crd, dir_point)

    def get_angle_to_target_ball(self):
        return angle_a_to_b(self.crd, self.char.target_ball.crd)
        


