from spider_body import spider_body
import constants as c_
from my_maths import angle_a_to_b

_IMG_ID0 = c_._in_IG_HEAD_SPIDER_ID0

class spider_head(spider_body):
    def __init__(self, spider, id, obj_group, stor, x, y,
                 img_gr = c_._IG_HEAD, img_id = 0,
                 friction = 0.1, solidity = 0.5,
                 detached_friction = 0.03,
                 def_size = c_._WH_SPDR_HEAD):
        spider_body.__init__(self, spider, id, obj_group, stor, x, y,
                             img_gr, img_id + _IMG_ID0, friction, solidity,
                             "HEAD OF PLAYER %s" % spider.player_id,
                             detached_friction, def_size,
                             visible = True,
                             vulnerability = 5)
        self.last_angle = 0

    def get_image_angle(self):
        dir_point = self.char.get_mouth_crd()
        ang = angle_a_to_b(self.crd, dir_point)
        self.last_angle = ang
        return ang
        
    
