from spider_body import spider_body
from my_maths import dist_a_to_b
from snd_holder import snd_holder
import time

import constants as c_

class spider_tongue(spider_body):
    sting_dist = 15 #is multiplied by self.r
    _SH_FIRE = snd_holder(c_._SG_FIRE, 2)
    _SH_HIT = snd_holder(c_._SG_HITS, 2)
    
    def __init__(self, spider, id, obj_group, stor, x, y):
        spider_body.__init__(self, spider, id, obj_group, stor, x, y,
                             c_._IG_SPDR_TONGUE, 0,
                             def_size = c_._WH_SPDR_TONGUE)
        self.meats = None
        self.stinging = None
        self.init_meat_dist_k = None
        self.make_detached()

        self.sh_fire = self._SH_FIRE
        self.now_sound = None
        
    def get_image_angle(self):
        return self.char.head.last_angle

    def set_tongue_meats(self, meats):
        self.meats = meats
        self.init_meat_dist_k = meats[0].dist_k

    def time_step(self, dt):
        if self.stinging is None:
            t = self.char.target_ball.crd
            d = self.sting_dist * self.r
            dx, dy = t[0] - self.crd[0], t[1] - self.crd[1]
            if ((abs(dx) <= d) and (abs(dy) <= d)):
                if dist_a_to_b((dx, dy), (0, 0)) <= d:
                    for m in self.meats:
                        m.set_dist_k(self.init_meat_dist_k * 2)
                    self.stinging = 0.2 #time when we hide tongue
                    self.now_sound = self.stor.sndf.get_sound(self.sh_fire)
            
        else:
            self.stinging -= dt
            if self.stinging <= 0:
                for m in self.meats:
                    m.set_dist_k(self.init_meat_dist_k)
                self.stinging = None

    def need_sound_when_hit_b(self, b):
        return ((b.obj_gr in c_._OGs_PLAYERS) and
                (b.obj_gr != self.obj_gr))
