from spider_body import spider_body
from my_maths import angle_a_to_b, dist_a_to_b
from common_ import print_
from animation import animation
from random import random
import constants as c_
from img_holder import img_holder
from snd_holder import snd_holder


def difficulty_changed(new_diffic):
    c = spidy
    def calc((v0, v1)):
        return v0 + (v1 - v0) * new_diffic / 4.0

    c.shot_speed = calc(c.def_shot_speed)
    c.run_speed = calc(c.def_run_speed)
    c.prob_agressive = calc(c.def_prob_agressive)


class spidy(spider_body):
    def_shot_speed = (0.2, 0.6)
    def_run_speed = (0.002, 0.0055)
    def_prob_agressive = (0.5, 1.01)


    shot_speed = run_speed = prob_agressive = None

    see_targ = 35 #multiplied by self radius
    critical_speed = 0.01 #start running back to daddy
    
    _SH_AGGR = snd_holder(c_._SG_FIRE, 4)

    def __init__(self, spider, id, obj_group, stor, x, y,
                 img_gr = None, img_id = 0,
                 friction = 0.05, solidity = 1.0,
                 def_size = c_._WH_SPIDY,
                 visible = True, collidable = True
                 ):
        spider_body.__init__(self, spider, id, obj_group, stor, x, y,
                             c_._IG_SPIDY, 0, friction, solidity,
                             def_size = def_size,
                             visible = visible,
                             collidable = collidable)
        
        self.string = "spidy %d of %s" % (self.id, self.char.string)
        self.my_meat = None
        self.is_running_to_targ = None
        self.my_target = None
        self.is_agressive = None
        self.is_agressor = None
        self.anim_running = animation(self.stor, self.ih_main, c_._IG_SPIDY,
                                      1, 3, "12321", delay = 0.2, autorun = False)

        self.sh_aggr = self._SH_AGGR
        self.now_sound = None
        

    def get_image_angle(self):
        if self.attached:
            return self.char.head.last_angle
        else:
##            return angle_a_to_b_rad(self.crd, self.char.
            return angle_a_to_b((0, 0), self.speed)
    
    def time_step(self, dt):
        if not self.attached:
            if self.is_running_to_targ:
                if self.is_agressor:
                    self.maybe_switch_agressiveness()
                targ = self.my_target.crd
                self.user_force_to_target(targ, self.run_speed)
            else:
                if ((abs(self.speed[0]) < self.critical_speed) and
                    (abs(self.speed[1]) < self.critical_speed)):
                    self.is_running_to_targ = True
                    self.my_target = self.my_meat.a
                    self.is_agressor = random() < self.prob_agressive
                    self.set_agressive(False)
                    self.anim_running.start()

                        
    def maybe_switch_agressiveness(self):
        dist = self.see_targ * self.r
        dx, dy = (self.crd[0] - self.char.target_ball.crd[0],
                  self.crd[1] - self.char.target_ball.crd[1])
        see = ((abs(dx) < dist) and (abs(dy) < dist))

        if see != self.is_agressive:
            self.set_agressive(see)
        
    def set_agressive(self, is_agr):
        id0 = is_agr and 4 or 0
        self.anim_running.id_from = id0 + 1
        self.anim_running.id_to = id0 + 3
        self.is_agressive = is_agr
        self.my_target = is_agr and self.char.target_ball or self.my_meat.a
        print_( "%s is agressive: %s" % (self.string, self.is_agressive) )

##        if is_agr:
##            self.now_sound = self.stor.sndf.get_sound(self.sh_aggr) 
    
    def shoot(self, target_crd, dist_to_target):
        "dist_to_target - not to recalc"
        self.make_detached()
        self.my_meat.set_active(False)
        self.user_force_to_target(target_crd, self.shot_speed, dist_to_target)
        self.is_running_to_targ = False

        
    def user_force_to_target(self, target_crd, spd, dist_to_target = None):
        dx, dy = (target_crd[0] - self.crd[0],
                  target_crd[1] - self.crd[1])
        if dist_to_target is None:
            dist_to_target = dist_a_to_b((dx, dy), (0, 0))
                 
        self.user_force[0] = spd * dx / dist_to_target
        self.user_force[1] = spd * dy / dist_to_target

    
    def glues_b(self, b):
        return ((self.is_running_to_targ) and
                (b is self.my_meat.a))

    def glue_b(self, b):
        self.make_attached()
        self.my_meat.set_active(True)
        self.is_running_to_targ = None
        self.anim_running.stop(img_holder(c_._IG_SPIDY, 0))
        self.is_agressive = None
        self.my_target = None
        self.is_agressor = None

        print_( "attached to %s" % self.player.string)
        
    
