import pygame
from player import player
from physics import physics
from image_factory import image_factory
from sound_factory import sound_factory
from toolbar import toolbar
from settings import settings
from dirty_rects import dirty_rects
import common_
import threading

class storage:

    def __init__(self, i_screen):
        common_.set_storage(self)
        
        self.settings = settings(self)
        self.screen = i_screen
        self.dirty = dirty_rects(self)
        self.background = pygame.Surface(i_screen.get_rect().size)
        self.imgf = image_factory(self)
        self.sndf = sound_factory(self)
        self.p1 = None
        self.p2 = None
        self.walls = None
        self.clouds = None
        self.bounties = None
        self.map = None
        self.physics = physics(self.screen, self)
        self.process_list = None
        self.toolbar = toolbar(self)
        self.sock = None
        self.net_storage = None

        self.print_lock = threading.Lock()
