from icon import icon
from img_holder import img_holder

class icon_flower(icon):
    def __init__(self, stor, player_info):
        icon.__init__(self, stor)
        self.player_info = player_info
        self.ih = img_holder(player_info.player.get_health_flower_img_gr(),
                             player_info.health)
        self.last_rendered_id = -1

    def render(self, visible):
        if not visible: return

        if self.player_info.health <= 0:
            self.ih.img_id = 0

        if self.ih.img_id == self.last_rendered_id:
            return
        self.last_rendered_id = self.ih.img_id
        self.render_(False)
        self.render_(True)

    def render_(self, visible):
        self.force_render(visible, self.get_back_image)
        if self.ih.img_id < 100:
            self.force_render(visible, self.get_front_image)

    def force_render(self, visible, func):
        img, img_r = func()
        img_r.center = self.rect.center
        if visible:
            self.stor.screen.blit(img, img_r)
        else:
            self.stor.screen.blit(self.stor.background, img_r, img_r)
        self.stor.dirty.new_unerase_rect(img_r)

    def get_back_image(self):
        ih = self.ih
        ih = img_holder(ih.img_gr, ih.img_id)
        ih.img_id /= 10
        return self.stor.imgf.get_image(ih).img
        
        
    def get_front_image(self):
        ih = self.ih
        ih = img_holder(ih.img_gr, ih.img_id)
        alpha_ = int((ih.img_id % 10) / 10.0 * 255.0)
        ih.img_id = ih.img_id / 10 + 1
        return self.stor.imgf.get_image_alpha(ih, alpha = alpha_).img
        
        
        


 
