class icon_group:
    def __init__(self, stor, initx, inity, wx, wy, left_to_right = 1, up_to_down = 0):
        """left_to_right: 1 = left_to_right, -1 = right_to_left, 0 = no change
           same for up_to_down"""

        self.stor = stor
        self.left, self.top = initx, inity
        self.wx, self.wy = wx, wy
        self.left_to_right = left_to_right
        self.up_to_down = up_to_down
        
        self.x, self.y = self.get_init_xy()
        self.dx = wx * left_to_right
        self.dy = wy * up_to_down
        self.icons = []

    def get_init_xy(self):
        if self.left_to_right == -1:
            initkdx = -1
        else:
            initkdx = 1

        if self.up_to_down == -1:
            initkdy = -1
        else:
            initkdy = 1

        return (self.left + initkdx * self.wx / 2.0,
                self.top  + initkdy * self.wy / 2.0)
                
            


    def add_icon(self, icon, post_shift_k = 1.0, shift = (0.0, 0.0)):
        x_shift, y_shift = self.wx * shift[0], self.wy * shift[1]
        self.icons.append(icon)
        self.icons[-1].rect.center = (self.x + x_shift, self.y + y_shift)
#        print self.icons[-1].rect
        
        self.x = int(self.x + self.dx * post_shift_k)
        self.y = int(self.y + self.dy * post_shift_k)

        return icon

    def render(self, visible):
        for icon in self.icons: icon.render(visible)
